/* A Bison parser, made by GNU Bison 2.1.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     K_ASSIGN = 258,
     K_CASE = 259,
     K_CATCH = 260,
     K_CATCHALL = 261,
     K_COMPENSATE = 262,
     K_COMPENSATIONHANDLER = 263,
     K_COPY = 264,
     K_CORRELATION = 265,
     K_CORRELATIONS = 266,
     K_CORRELATIONSET = 267,
     K_CORRELATIONSETS = 268,
     K_EMPTY = 269,
     K_EVENTHANDLERS = 270,
     K_FAULTHANDLERS = 271,
     K_FLOW = 272,
     K_FROM = 273,
     K_IMPORT = 274,
     K_INVOKE = 275,
     K_LINK = 276,
     K_LINKS = 277,
     K_ONALARM = 278,
     K_ONMESSAGE = 279,
     K_OTHERWISE = 280,
     K_PARTNER = 281,
     K_PARTNERLINK = 282,
     K_PARTNERLINKS = 283,
     K_PARTNERS = 284,
     K_PICK = 285,
     K_PROCESS = 286,
     K_RECEIVE = 287,
     K_REPLY = 288,
     K_SCOPE = 289,
     K_SEQUENCE = 290,
     K_SOURCE = 291,
     K_SWITCH = 292,
     K_TARGET = 293,
     K_TERMINATE = 294,
     K_THROW = 295,
     K_TO = 296,
     K_VARIABLE = 297,
     K_VARIABLES = 298,
     K_WAIT = 299,
     K_WHILE = 300,
     X_OPEN = 301,
     X_SLASH = 302,
     X_CLOSE = 303,
     X_NEXT = 304,
     X_EQUALS = 305,
     X_NAME = 306,
     X_STRING = 307
   };
#endif
/* Tokens.  */
#define K_ASSIGN 258
#define K_CASE 259
#define K_CATCH 260
#define K_CATCHALL 261
#define K_COMPENSATE 262
#define K_COMPENSATIONHANDLER 263
#define K_COPY 264
#define K_CORRELATION 265
#define K_CORRELATIONS 266
#define K_CORRELATIONSET 267
#define K_CORRELATIONSETS 268
#define K_EMPTY 269
#define K_EVENTHANDLERS 270
#define K_FAULTHANDLERS 271
#define K_FLOW 272
#define K_FROM 273
#define K_IMPORT 274
#define K_INVOKE 275
#define K_LINK 276
#define K_LINKS 277
#define K_ONALARM 278
#define K_ONMESSAGE 279
#define K_OTHERWISE 280
#define K_PARTNER 281
#define K_PARTNERLINK 282
#define K_PARTNERLINKS 283
#define K_PARTNERS 284
#define K_PICK 285
#define K_PROCESS 286
#define K_RECEIVE 287
#define K_REPLY 288
#define K_SCOPE 289
#define K_SEQUENCE 290
#define K_SOURCE 291
#define K_SWITCH 292
#define K_TARGET 293
#define K_TERMINATE 294
#define K_THROW 295
#define K_TO 296
#define K_VARIABLE 297
#define K_VARIABLES 298
#define K_WAIT 299
#define K_WHILE 300
#define X_OPEN 301
#define X_SLASH 302
#define X_CLOSE 303
#define X_NEXT 304
#define X_EQUALS 305
#define X_NAME 306
#define X_STRING 307




/* Copy the first part of user declarations.  */


/*!
 * \file bpel-syntax.cc
 *
 * \brief BPEL grammar (implementation)
 *
 * This file defines and implements the grammar of BPEL using standard 
 * BNF-rules to describe the originally XML-based syntax as it is specified in
 * the BPEL4WS 1.1 specification. All terminals are passed from the lexer
 * (implemented in \ref bpel-lexic.c). Besides simple syntax-checking the
 * grammar is used to build the abstract syntax tree as it is defined in
 * bpel-abstract.k and implemented in \ref bpel-abstract.cc and
 * \ref bpel-abstract.h.
 * 
 * \author  
 *          - responsible: Niels Lohmann <nlohmann@informatik.hu-berlin.de>
 *          - last changes of: \$Author: gierds $
 *          
 * \date 
 *          - created: 2005/11/10
 *          - last changed: \$Date: 2006/02/23 15:00:00 $
 * 
 * \note    This file is part of the tool BPEL2oWFN and was created during the
 *          project "Tools4BPEL" at the Humboldt-Universit�t zu Berlin. See
 *          http://www.informatik.hu-berlin.de/top/tools4bpel for details.
 *
 * \note    This file was created using GNU Bison reading file bpel-syntax.yy.
 *          See http://www.gnu.org/software/bison/bison.html for details
 *
 * \version \$Revision: 1.125 $
 * 
 * \todo
 *          - add rules to ignored everything non-BPEL
 */

	
/*!
 * \file bpel-syntax.h
 * \brief BPEL grammar (interface)
 *
 * See \ref bpel-syntax.c for more information.
 */





// options for Bison
#define YYDEBUG 1
#define YYERROR_VERBOSE 1  // for verbose error messages


// to avoid the message "parser stack overflow"
#define YYMAXDEPTH 1000000
#define YYINITDEPTH 10000


// generated by Kimwitu++
#include "bpel-kc-k.h" // phylum definitions
#include "bpel-kc-yystype.h" // data types for tokens and non-terminals

#include <map>

// from flex
extern char* yytext;
extern int yylex();


// defined in "debug.h"
extern int yyerror(const char *);


using namespace kc;
using namespace std;

// symbol table
#include "symbol-table.h"

/// an instance of the symbol table
SymbolTable symTab = SymbolTable();
SymbolTableEntry* currentSymTabEntry;
unsigned int currentSymTabEntryKey = 0;

// manage attributes
#include "bpel-attributes.h"

/// an instance of the attribute manager
attributeManager att = attributeManager();

#include "check-symbols.h"

/// from check-symbols
SymbolManager symMan = SymbolManager();

/// needed to distinguish context of tPartnerLink
bool inPartners = false;

/// needed to check occurrence of links within whiles
bool inWhile = false;

/// needed to tag handlers
integer currentScopeId;

/// needed to tag scopes
map <integer, integer> parent;

/// the root of the abstract syntax tree
tProcess TheProcess;

/// needed to find out if a FH has a <catchAll> element
bool hasCatchAll = false;

/// stack for checking for FaultHandler
stack<bool> isInFH;
/// stack for checking for CompensationHandler
stack< pair<bool,int> > isInCH;
int hasCompensate;



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 1
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
typedef int YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 219 of yacc.c.  */


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T) && (defined (__STDC__) || defined (__cplusplus))
# include <stddef.h> /* INFRINGES ON USER NAME SPACE */
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if defined (__STDC__) || defined (__cplusplus)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     define YYINCLUDED_STDLIB_H
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2005 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM ((YYSIZE_T) -1)
#  endif
#  ifdef __cplusplus
extern "C" {
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if (! defined (malloc) && ! defined (YYINCLUDED_STDLIB_H) \
	&& (defined (__STDC__) || defined (__cplusplus)))
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if (! defined (free) && ! defined (YYINCLUDED_STDLIB_H) \
	&& (defined (__STDC__) || defined (__cplusplus)))
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifdef __cplusplus
}
#  endif
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  4
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   399

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  53
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  133
/* YYNRULES -- Number of rules. */
#define YYNRULES  193
/* YYNRULES -- Number of states. */
#define YYNSTATES  459

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   307

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short int yyprhs[] =
{
       0,     0,     3,     4,     5,    25,    26,    32,    34,    36,
      38,    40,    42,    44,    46,    48,    50,    52,    54,    56,
      58,    60,    62,    63,    70,    73,    77,    84,    89,    90,
      91,    92,   100,   103,   107,   115,   120,   121,   122,   123,
     132,   133,   137,   138,   147,   148,   157,   158,   159,   168,
     169,   170,   179,   180,   184,   185,   189,   190,   191,   202,
     203,   204,   214,   215,   222,   225,   229,   236,   241,   242,
     243,   250,   253,   257,   264,   269,   270,   271,   278,   281,
     285,   292,   297,   298,   299,   308,   309,   315,   316,   317,
     318,   332,   333,   339,   340,   341,   342,   353,   354,   360,
     361,   362,   372,   373,   379,   380,   381,   382,   392,   395,
     399,   408,   415,   424,   429,   430,   437,   442,   443,   444,
     453,   454,   460,   461,   462,   471,   472,   478,   479,   480,
     489,   490,   496,   497,   498,   507,   508,   514,   515,   516,
     517,   518,   530,   534,   539,   540,   541,   549,   552,   556,
     563,   568,   569,   570,   571,   572,   584,   588,   593,   594,
     595,   596,   606,   607,   608,   617,   618,   619,   620,   632,
     633,   634,   644,   645,   646,   647,   661,   662,   663,   664,
     665,   683,   686,   687,   691,   698,   703,   704,   705,   709,
     716,   721,   722,   723
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const short int yyrhs[] =
{
      54,     0,    -1,    -1,    -1,    46,    31,    55,   185,    56,
      49,    57,    59,    63,    86,    90,    68,    74,    76,    58,
      49,    47,    31,    48,    -1,    -1,    19,   185,    47,    49,
      57,    -1,    98,    -1,   102,    -1,   107,    -1,   112,    -1,
     116,    -1,   125,    -1,   129,    -1,   137,    -1,   141,    -1,
     151,    -1,   162,    -1,   166,    -1,   169,    -1,   173,    -1,
     133,    -1,    -1,    28,    49,    60,    47,    28,    49,    -1,
      61,    49,    -1,    61,    49,    60,    -1,    27,    62,   185,
      49,    47,    27,    -1,    27,    62,   185,    47,    -1,    -1,
      -1,    -1,    29,    49,    64,    65,    47,    29,    49,    -1,
      66,    49,    -1,    66,    49,    65,    -1,    26,    67,   185,
      49,    60,    47,    26,    -1,    26,    67,   185,    47,    -1,
      -1,    -1,    -1,    16,    49,    69,    70,    73,    47,    16,
      49,    -1,    -1,    71,    49,    70,    -1,    -1,     5,    72,
     185,    49,    58,    49,    47,     5,    -1,    -1,     6,   185,
      49,    58,    49,    47,     6,    49,    -1,    -1,    -1,     8,
      49,    75,    58,    49,    47,     8,    49,    -1,    -1,    -1,
      15,    49,    77,    78,    79,    47,    15,    49,    -1,    -1,
      80,    49,    78,    -1,    -1,    83,    49,    79,    -1,    -1,
      -1,    24,    81,   185,    49,    82,    94,    58,    49,    47,
      24,    -1,    -1,    -1,    23,    84,   185,    49,    85,    58,
      49,    47,    23,    -1,    -1,    43,    49,    87,    47,    43,
      49,    -1,    88,    49,    -1,    88,    49,    87,    -1,    42,
      89,   185,    49,    47,    42,    -1,    42,    89,   185,    47,
      -1,    -1,    -1,    13,    49,    91,    47,    13,    49,    -1,
      92,    49,    -1,    92,    49,    91,    -1,    12,    93,   185,
      49,    47,    12,    -1,    12,    93,   185,    47,    -1,    -1,
      -1,    11,    49,    95,    47,    11,    49,    -1,    96,    49,
      -1,    96,    49,    95,    -1,    10,    97,   185,    49,    47,
      10,    -1,    10,    97,   185,    47,    -1,    -1,    -1,    14,
     101,   185,    99,    49,   178,    47,    14,    -1,    -1,    14,
     101,   185,   100,    47,    -1,    -1,    -1,    -1,    20,   106,
     185,   103,    49,   104,   178,    94,    70,    73,    74,    47,
      20,    -1,    -1,    20,   106,   185,   105,    47,    -1,    -1,
      -1,    -1,    32,   111,   185,   108,    49,   109,   178,    94,
      47,    32,    -1,    -1,    32,   111,   185,   110,    47,    -1,
      -1,    -1,    33,   115,   185,   113,    49,   178,    94,    47,
      33,    -1,    -1,    33,   115,   185,   114,    47,    -1,    -1,
      -1,    -1,     3,   117,   185,   118,    49,   178,   119,    47,
       3,    -1,   120,    49,    -1,   120,    49,   119,    -1,     9,
      49,   121,    49,   123,    49,    47,     9,    -1,    18,   122,
     185,    49,    47,    18,    -1,    18,   122,   185,    48,    51,
      46,    47,    18,    -1,    18,   122,   185,    47,    -1,    -1,
      41,   124,   185,    49,    47,    41,    -1,    41,   124,   185,
      47,    -1,    -1,    -1,    44,   128,   185,   126,    49,   178,
      47,    44,    -1,    -1,    44,   128,   185,   127,    47,    -1,
      -1,    -1,    40,   132,   185,   130,    49,   178,    47,    40,
      -1,    -1,    40,   132,   185,   131,    47,    -1,    -1,    -1,
       7,   136,   185,   134,    49,   178,    47,     7,    -1,    -1,
       7,   136,   185,   135,    47,    -1,    -1,    -1,    39,   140,
     185,   138,    49,   178,    47,    39,    -1,    -1,    39,   140,
     185,   139,    47,    -1,    -1,    -1,    -1,    -1,    17,   142,
     185,   143,    49,   144,   178,   147,   145,    47,    17,    -1,
     146,    58,    49,    -1,   146,    58,    49,   145,    -1,    -1,
      -1,    22,   185,    49,   148,    47,    22,    49,    -1,   149,
      49,    -1,   149,    49,   148,    -1,    21,   150,   185,    49,
      47,    21,    -1,    21,   150,   185,    47,    -1,    -1,    -1,
      -1,    -1,    37,   152,   185,   153,    49,   178,   154,   155,
     160,    47,    37,    -1,   156,   157,    49,    -1,   156,   157,
      49,   155,    -1,    -1,    -1,    -1,     4,   158,   185,    49,
     159,    58,    49,    47,     4,    -1,    -1,    -1,    25,    49,
     161,    58,    49,    47,    25,    49,    -1,    -1,    -1,    -1,
      45,   163,   185,   164,    49,   178,   165,    58,    49,    47,
      45,    -1,    -1,    -1,    35,   167,   185,   168,    49,   178,
     145,    47,    35,    -1,    -1,    -1,    -1,    30,   170,   185,
     171,    49,   178,   172,    80,    49,    78,    79,    47,    30,
      -1,    -1,    -1,    -1,    -1,    34,   174,   185,   175,    49,
     176,   178,   177,    86,    90,    68,    74,    76,    58,    49,
      47,    34,    -1,   179,   182,    -1,    -1,   180,    49,   179,
      -1,    38,   181,   185,    49,    47,    38,    -1,    38,   181,
     185,    47,    -1,    -1,    -1,   183,    49,   182,    -1,    36,
     184,   185,    49,    47,    36,    -1,    36,   184,   185,    47,
      -1,    -1,    -1,    51,    50,    52,   185,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,   288,   288,   292,   287,   336,   338,   370,   373,   380,
     383,   386,   389,   392,   395,   398,   402,   406,   409,   413,
     417,   421,   447,   448,   453,   455,   460,   476,   495,   520,
     522,   521,   529,   531,   536,   539,   545,   577,   583,   582,
     603,   604,   610,   609,   623,   625,   652,   658,   657,   717,
     720,   719,   734,   737,   745,   748,   756,   760,   755,   781,
     785,   780,   821,   822,   827,   829,   834,   845,   859,   888,
     889,   894,   896,   901,   904,   912,   923,   924,   929,   933,
     940,   946,   955,   978,   976,  1012,  1010,  1039,  1076,  1090,
    1074,  1243,  1241,  1298,  1335,  1349,  1333,  1378,  1376,  1416,
    1453,  1451,  1498,  1496,  1535,  1561,  1565,  1560,  1598,  1600,
    1605,  1621,  1634,  1648,  1664,  1679,  1688,  1700,  1726,  1724,
    1760,  1758,  1789,  1814,  1812,  1850,  1848,  1880,  1902,  1900,
    1958,  1956,  2009,  2032,  2030,  2064,  2062,  2091,  2116,  2120,
    2134,  2115,  2164,  2172,  2183,  2191,  2192,  2197,  2199,  2204,
    2209,  2217,  2244,  2248,  2263,  2243,  2295,  2303,  2314,  2322,
    2326,  2321,  2345,  2368,  2367,  2399,  2403,  2418,  2398,  2453,
    2457,  2452,  2530,  2534,  2549,  2529,  2605,  2609,  2623,  2630,
    2604,  2686,  2700,  2702,  2708,  2715,  2725,  2732,  2735,  2742,
    2754,  2769,  2778,  2781
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "K_ASSIGN", "K_CASE", "K_CATCH",
  "K_CATCHALL", "K_COMPENSATE", "K_COMPENSATIONHANDLER", "K_COPY",
  "K_CORRELATION", "K_CORRELATIONS", "K_CORRELATIONSET",
  "K_CORRELATIONSETS", "K_EMPTY", "K_EVENTHANDLERS", "K_FAULTHANDLERS",
  "K_FLOW", "K_FROM", "K_IMPORT", "K_INVOKE", "K_LINK", "K_LINKS",
  "K_ONALARM", "K_ONMESSAGE", "K_OTHERWISE", "K_PARTNER", "K_PARTNERLINK",
  "K_PARTNERLINKS", "K_PARTNERS", "K_PICK", "K_PROCESS", "K_RECEIVE",
  "K_REPLY", "K_SCOPE", "K_SEQUENCE", "K_SOURCE", "K_SWITCH", "K_TARGET",
  "K_TERMINATE", "K_THROW", "K_TO", "K_VARIABLE", "K_VARIABLES", "K_WAIT",
  "K_WHILE", "X_OPEN", "X_SLASH", "X_CLOSE", "X_NEXT", "X_EQUALS",
  "X_NAME", "X_STRING", "$accept", "tProcess", "@1", "@2", "imports",
  "activity", "tPartnerLinks", "tPartnerLink_list", "tPartnerLink",
  "genSymTabEntry_PartnerLink", "tPartners", "@3", "tPartner_list",
  "tPartner", "genSymTabEntry_Partner", "tFaultHandlers", "@4",
  "tCatch_list", "tCatch", "@5", "tCatchAll", "tCompensationHandler", "@6",
  "tEventHandlers", "@7", "tOnMessage_list", "tOnAlarm_list", "tOnMessage",
  "@8", "@9", "tOnAlarm", "@10", "@11", "tVariables", "tVariable_list",
  "tVariable", "genSymTabEntry_Variable", "tCorrelationSets",
  "tCorrelationSet_list", "tCorrelationSet",
  "genSymTabEntry_CorrelationSet", "tCorrelations", "tCorrelation_list",
  "tCorrelation", "genSymTabEntry_Correlation", "tEmpty", "@12", "@13",
  "genSymTabEntry_Empty", "tInvoke", "@14", "@15", "@16",
  "genSymTabEntry_Invoke", "tReceive", "@17", "@18", "@19",
  "genSymTabEntry_Receive", "tReply", "@20", "@21", "genSymTabEntry_Reply",
  "tAssign", "@22", "@23", "tCopy_list", "tCopy", "tFrom",
  "genSymTabEntry_From", "tTo", "genSymTabEntry_To", "tWait", "@24", "@25",
  "genSymTabEntry_Wait", "tThrow", "@26", "@27", "genSymTabEntry_Throw",
  "tCompensate", "@28", "@29", "genSymTabEntry_Compensate", "tTerminate",
  "@30", "@31", "genSymTabEntry_Terminate", "tFlow", "@32", "@33", "@34",
  "activity_list", "descent_activity_list", "tLinks", "tLink_list",
  "tLink", "genSymTabEntry_Link", "tSwitch", "@35", "@36", "@37",
  "tCase_list", "descent_case_list", "tCase", "@38", "@39", "tOtherwise",
  "@40", "tWhile", "@41", "@42", "@43", "tSequence", "@44", "@45", "tPick",
  "@46", "@47", "@48", "tScope", "@49", "@50", "@51", "@52",
  "standardElements", "tTarget_list", "tTarget", "genSymTabEntry_Target",
  "tSource_list", "tSource", "genSymTabEntry_Source",
  "arbitraryAttributes", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    53,    55,    56,    54,    57,    57,    58,    58,    58,
      58,    58,    58,    58,    58,    58,    58,    58,    58,    58,
      58,    58,    59,    59,    60,    60,    61,    61,    62,    63,
      64,    63,    65,    65,    66,    66,    67,    68,    69,    68,
      70,    70,    72,    71,    73,    73,    74,    75,    74,    76,
      77,    76,    78,    78,    79,    79,    81,    82,    80,    84,
      85,    83,    86,    86,    87,    87,    88,    88,    89,    90,
      90,    91,    91,    92,    92,    93,    94,    94,    95,    95,
      96,    96,    97,    99,    98,   100,    98,   101,   103,   104,
     102,   105,   102,   106,   108,   109,   107,   110,   107,   111,
     113,   112,   114,   112,   115,   117,   118,   116,   119,   119,
     120,   121,   121,   121,   122,   123,   123,   124,   126,   125,
     127,   125,   128,   130,   129,   131,   129,   132,   134,   133,
     135,   133,   136,   138,   137,   139,   137,   140,   142,   143,
     144,   141,   145,   145,   146,   147,   147,   148,   148,   149,
     149,   150,   152,   153,   154,   151,   155,   155,   156,   158,
     159,   157,   160,   161,   160,   163,   164,   165,   162,   167,
     168,   166,   170,   171,   172,   169,   174,   175,   176,   177,
     173,   178,   179,   179,   180,   180,   181,   182,   182,   183,
     183,   184,   185,   185
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     0,     0,    19,     0,     5,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     6,     2,     3,     6,     4,     0,     0,
       0,     7,     2,     3,     7,     4,     0,     0,     0,     8,
       0,     3,     0,     8,     0,     8,     0,     0,     8,     0,
       0,     8,     0,     3,     0,     3,     0,     0,    10,     0,
       0,     9,     0,     6,     2,     3,     6,     4,     0,     0,
       6,     2,     3,     6,     4,     0,     0,     6,     2,     3,
       6,     4,     0,     0,     8,     0,     5,     0,     0,     0,
      13,     0,     5,     0,     0,     0,    10,     0,     5,     0,
       0,     9,     0,     5,     0,     0,     0,     9,     2,     3,
       8,     6,     8,     4,     0,     6,     4,     0,     0,     8,
       0,     5,     0,     0,     8,     0,     5,     0,     0,     8,
       0,     5,     0,     0,     8,     0,     5,     0,     0,     0,
       0,    11,     3,     4,     0,     0,     7,     2,     3,     6,
       4,     0,     0,     0,     0,    11,     3,     4,     0,     0,
       0,     9,     0,     0,     8,     0,     0,     0,    11,     0,
       0,     9,     0,     0,     0,    13,     0,     0,     0,     0,
      17,     2,     0,     3,     6,     4,     0,     0,     3,     6,
       4,     0,     0,     4
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     0,     0,     2,     1,   192,     0,     3,     0,     0,
     192,     5,   193,   192,    22,     0,     0,    29,     0,     0,
       0,    62,     5,    28,     0,     0,    30,     0,    69,     6,
     192,     0,    24,     0,     0,     0,    37,     0,     0,    25,
      36,     0,     0,    68,     0,     0,     0,     0,    46,    27,
       0,    23,   192,     0,    32,   192,     0,    64,    75,     0,
       0,    38,     0,    49,     0,     0,     0,    33,     0,     0,
      65,   192,     0,    71,    40,    47,     0,     0,    26,    35,
       0,    31,    67,     0,    63,     0,     0,    72,    42,    44,
       0,     0,    50,   105,   132,    87,   138,    93,   172,    99,
     104,   176,   169,   152,   137,   127,   122,   165,     0,     7,
       8,     9,    10,    11,    12,    13,    21,    14,    15,    16,
      17,    18,    19,    20,     0,     0,    74,     0,    70,   192,
     192,     0,    40,     0,    52,   192,   192,   192,   192,   192,
     192,   192,   192,   192,   192,   192,   192,   192,   192,   192,
       0,     0,    66,     0,     0,     0,     0,    41,     0,    56,
      54,     0,   106,   128,    83,   139,    88,   173,    94,   100,
     177,   170,   153,   133,   123,   118,   166,     0,    34,    73,
       0,     0,     0,     0,   192,    59,     0,     0,    52,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    39,     0,     0,   192,     0,
      54,    53,   182,   182,   131,   182,    86,   140,    89,    92,
     182,    95,    98,   182,   103,   178,   182,   182,   182,   136,
     182,   126,   182,   121,   182,     4,     0,     0,    48,    57,
       0,     0,    55,   186,     0,   187,     0,     0,     0,   182,
     182,   174,   182,    76,   182,   144,   154,     0,     0,     0,
     167,     0,     0,    76,    60,    51,   192,     0,     0,     0,
     191,   181,     0,   182,     0,     0,   145,    76,     0,    76,
       0,     0,   179,     0,     0,   158,     0,     0,     0,     0,
      43,     0,     0,     0,     0,     0,     0,   108,   192,   187,
     183,   129,    84,   192,   144,    40,     0,     0,     0,     0,
      62,     0,     0,   162,     0,   134,   124,   119,     0,    45,
       0,     0,   185,     0,   114,     0,   107,   109,     0,   188,
       0,     0,    44,    52,     0,    82,     0,     0,   101,    69,
     171,   144,     0,     0,   159,     0,     0,     0,     0,     0,
     192,     0,   190,     0,     0,     0,    46,    54,    96,   192,
       0,    78,    37,   143,   163,     0,   192,   156,     0,     0,
       0,   184,     0,   117,     0,     0,   151,     0,     0,   141,
       0,     0,     0,     0,    79,    46,     0,   155,     0,   157,
     168,    58,    61,   113,     0,     0,   192,     0,   189,   192,
       0,   147,     0,     0,    81,     0,    77,    49,     0,   160,
       0,     0,     0,     0,     0,     0,   148,    90,   175,     0,
       0,     0,     0,     0,   111,   116,     0,   110,   150,     0,
     146,    80,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   112,   115,   149,     0,   164,     0,   180,   161
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short int yydefgoto[] =
{
      -1,     2,     5,     9,    14,   108,    17,    24,    25,    30,
      21,    33,    41,    42,    52,    48,    74,    89,    90,   129,
     131,    63,    91,    77,   134,   160,   186,   161,   184,   273,
     187,   218,   303,    28,    44,    45,    55,    36,    59,    60,
      71,   291,   346,   347,   369,   109,   192,   193,   137,   110,
     195,   260,   196,   139,   111,   198,   262,   199,   141,   112,
     200,   201,   142,   113,   135,   189,   278,   279,   335,   360,
     384,   406,   114,   209,   210,   148,   115,   207,   208,   147,
     116,   190,   191,   136,   117,   205,   206,   146,   118,   138,
     194,   259,   293,   294,   314,   387,   388,   409,   119,   145,
     204,   295,   323,   324,   355,   376,   432,   353,   396,   120,
     149,   211,   299,   121,   144,   203,   122,   140,   197,   288,
     123,   143,   202,   264,   320,   254,   255,   256,   276,   281,
     282,   308,     7
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -345
static const short int yypact[] =
{
     -11,   -15,    40,  -345,  -345,    -4,    12,  -345,     8,    15,
      -4,    46,  -345,    -4,    39,    21,    23,    45,    27,    51,
      30,    37,    46,  -345,    34,    33,  -345,    35,    70,  -345,
      -4,    57,    51,    60,    47,    38,    72,   -39,    49,  -345,
    -345,    52,    53,  -345,    54,    55,    82,    56,    88,  -345,
      59,  -345,    -4,    71,    60,    -4,    64,    47,  -345,    61,
      62,  -345,    63,    94,    76,   -30,    65,  -345,   -24,    66,
    -345,    -4,    97,    82,   108,  -345,    67,     4,  -345,  -345,
      51,  -345,  -345,    74,  -345,   -20,    68,  -345,  -345,   112,
      73,     4,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,
    -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,    75,  -345,
    -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,
    -345,  -345,  -345,  -345,    93,    81,  -345,    95,  -345,    -4,
      -4,    96,   108,    92,   120,    -4,    -4,    -4,    -4,    -4,
      -4,    -4,    -4,    -4,    -4,    -4,    -4,    -4,    -4,    -4,
      98,   121,  -345,   134,    99,   100,   135,  -345,   103,  -345,
     130,   105,  -345,   109,   110,  -345,   111,  -345,   113,   114,
    -345,  -345,  -345,   115,   116,   117,  -345,   124,  -345,  -345,
       4,     4,   118,   157,    -4,  -345,   119,   122,   120,   123,
     126,   129,   128,   131,   132,   133,   136,   137,   138,   141,
     140,   143,   142,   144,   145,   146,   149,   148,   151,   150,
     153,   152,   125,   154,   156,  -345,   158,   161,    -4,   155,
     130,  -345,   164,   164,  -345,   164,  -345,  -345,  -345,  -345,
     164,  -345,  -345,   164,  -345,  -345,   164,   164,   164,  -345,
     164,  -345,   164,  -345,   164,  -345,   159,   167,  -345,  -345,
     162,   166,  -345,  -345,   160,   180,   168,   171,   172,   164,
     164,  -345,   164,   169,   164,  -345,  -345,   173,   174,   175,
    -345,   163,   178,   169,  -345,  -345,    -4,   176,   177,   179,
    -345,  -345,   181,   164,   185,   165,   201,   169,   120,   169,
     182,   186,  -345,   187,     4,  -345,   188,   189,   191,     4,
    -345,   183,     4,     4,   -17,   208,   233,   160,    -4,   180,
    -345,  -345,  -345,    -4,  -345,   108,   190,   193,   227,   205,
      37,   206,   194,   217,   240,  -345,  -345,  -345,   196,  -345,
     197,   198,  -345,   202,  -345,   199,  -345,  -345,   -16,  -345,
     203,   204,   112,   120,   218,  -345,   207,   209,  -345,    70,
    -345,   210,   211,   212,  -345,   213,   214,   216,   220,   215,
      -4,   223,  -345,   221,   234,   239,    88,   130,  -345,    -4,
     254,   227,    72,  -345,  -345,   232,    -4,   266,   226,   248,
     250,  -345,   -34,  -345,   225,   241,  -345,   228,   229,  -345,
     235,   236,     3,   230,  -345,    88,     4,  -345,   231,  -345,
    -345,  -345,  -345,  -345,   237,   238,    -4,   242,  -345,    -4,
     259,   234,   256,   257,  -345,   243,  -345,    94,   244,  -345,
     245,   268,     6,   275,    10,   246,  -345,  -345,  -345,   282,
       4,   247,     4,   249,  -345,  -345,   252,  -345,  -345,   253,
    -345,  -345,   255,   272,   258,   283,   261,   284,   262,   263,
     264,  -345,  -345,  -345,   274,  -345,   306,  -345,  -345
};

/* YYPGOTO[NTERM-NUM].  */
static const short int yypgoto[] =
{
    -345,  -345,  -345,  -345,   291,   -90,  -345,   -26,  -345,  -345,
    -345,  -345,   260,  -345,  -345,   -57,  -345,  -130,  -345,  -345,
     -25,  -344,  -345,  -101,  -345,  -184,  -215,    31,  -345,  -345,
    -345,  -345,  -345,    -2,   265,  -345,  -345,   -29,   251,  -345,
    -345,  -261,   -50,  -345,  -345,  -345,  -345,  -345,  -345,  -345,
    -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,
    -345,  -345,  -345,  -345,  -345,  -345,    16,  -345,  -345,  -345,
    -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,
    -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,
    -345,  -345,  -305,  -345,  -345,   -86,  -345,  -345,  -345,  -345,
    -345,  -345,   -51,  -345,  -345,  -345,  -345,  -345,  -345,  -345,
    -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,  -345,
    -345,  -345,  -345,  -345,  -345,  -167,    44,  -345,  -345,    19,
    -345,  -345,   -10
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -159
static const short int yytable[] =
{
      12,   133,   157,    15,   221,   252,    39,    93,    49,   341,
      50,    94,   302,   403,   404,   405,     3,    79,    95,    80,
      37,    96,   390,    82,    97,    83,   315,   126,   317,   127,
     332,   362,   333,   363,    98,     1,    99,   100,   101,   102,
       4,   103,    65,   104,   105,    68,   373,     6,   106,   107,
     414,   417,   415,   435,   124,   436,   257,   438,   258,   439,
      10,    85,     8,   261,    11,    13,   263,    16,    18,   265,
     266,   267,    19,   268,    20,   269,    22,   270,    23,    26,
      27,    31,    32,    35,    34,    38,    40,    46,    47,    43,
     213,   214,   286,   287,    58,   289,    62,   292,    51,    53,
      66,    56,    54,    78,    57,    61,    64,    69,    72,    76,
      86,    73,    75,    88,    81,    84,    92,   128,   130,   154,
     155,   125,   132,   152,   150,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     151,   158,   153,   156,   159,   177,   179,   178,   180,   181,
     183,   182,   391,   185,   188,   212,  -130,   -85,   -91,   367,
     -97,  -102,  -135,  -125,  -120,   216,   219,   215,   300,   277,
     251,   220,   222,   245,   217,   223,   224,   225,   226,   312,
     290,   227,   228,   229,   301,   342,   230,   231,   232,   233,
     234,   235,   311,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   253,   246,   322,   247,   271,   248,   250,   328,
     249,   274,   330,   331,   272,   275,   280,   283,   284,   285,
     296,   297,   298,   313,   306,   305,   334,   325,   307,   326,
     309,   318,   329,   319,   321,   327,   336,   345,   348,   343,
     344,   350,   352,   351,   354,   356,   357,   358,   361,   359,
     368,   365,   364,   381,   370,   386,   389,  -142,   371,   375,
     374,   378,   377,   379,   383,   393,   304,   380,   385,   397,
    -158,   400,   401,   402,   407,   410,   427,   408,   411,   416,
     419,   425,   412,   413,   437,   421,   434,   428,   420,   423,
     429,   433,   441,   431,   443,   440,   445,   449,   338,   446,
     447,   451,   452,   340,   448,   453,   418,   450,   457,   454,
     458,   456,   455,    29,    67,   395,   430,   366,   349,   316,
     372,   394,    70,   337,    87,   426,   399,   310,   339,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     442,     0,   444,     0,     0,     0,     0,     0,     0,     0,
     382,     0,     0,     0,     0,     0,     0,     0,     0,   392,
       0,     0,     0,     0,     0,     0,   398,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   422,     0,     0,   424
};

static const short int yycheck[] =
{
      10,    91,   132,    13,   188,   220,    32,     3,    47,   314,
      49,     7,   273,    47,    48,    49,    31,    47,    14,    49,
      30,    17,   366,    47,    20,    49,   287,    47,   289,    49,
      47,    47,    49,    49,    30,    46,    32,    33,    34,    35,
       0,    37,    52,    39,    40,    55,   351,    51,    44,    45,
      47,   395,    49,    47,    80,    49,   223,    47,   225,    49,
      52,    71,    50,   230,    49,    19,   233,    28,    47,   236,
     237,   238,    49,   240,    29,   242,    49,   244,    27,    49,
      43,    47,    49,    13,    49,    28,    26,    49,    16,    42,
     180,   181,   259,   260,    12,   262,     8,   264,    49,    47,
      29,    47,    49,    27,    49,    49,    47,    43,    47,    15,
      13,    49,    49,     5,    49,    49,    49,    49,     6,   129,
     130,    47,    49,    42,    49,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
      47,    49,    47,    47,    24,    47,    12,    26,    49,    49,
      47,    16,   367,    23,    49,    31,    47,    47,    47,   343,
      47,    47,    47,    47,    47,     8,    47,    49,     5,     9,
      15,    49,    49,    48,   184,    49,    47,    49,    47,    14,
      11,    49,    49,    47,     6,   315,    49,    49,    47,    49,
      47,    49,     7,    49,    49,    49,    47,    49,    47,    49,
      47,    49,    38,    49,   294,    49,    47,    49,   218,   299,
      49,    49,   302,   303,    47,    49,    36,    49,    47,    47,
      47,    47,    47,    22,    47,    49,    18,    39,    49,    40,
      49,    49,    49,    47,    47,    44,     3,    10,    33,    49,
      47,    35,    25,    49,     4,    49,    49,    49,    49,    47,
      32,    47,    49,    38,    47,    21,    17,    47,    49,    47,
      49,    47,    49,    47,    41,    11,   276,    47,    47,    37,
       4,    45,    24,    23,    49,    47,    20,    36,    49,    49,
      49,    22,    47,    47,     9,    47,    18,    30,    51,    47,
      47,    46,    10,    49,    47,    49,    47,    25,   308,    47,
      47,    18,    41,   313,    49,    21,   396,    49,    34,    47,
       4,    47,    49,    22,    54,   372,   417,   342,   320,   288,
     349,   371,    57,   307,    73,   411,   377,   283,   309,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     430,    -1,   432,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     360,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   369,
      -1,    -1,    -1,    -1,    -1,    -1,   376,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   406,    -1,    -1,   409
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    46,    54,    31,     0,    55,    51,   185,    50,    56,
      52,    49,   185,    19,    57,   185,    28,    59,    47,    49,
      29,    63,    49,    27,    60,    61,    49,    43,    86,    57,
      62,    47,    49,    64,    49,    13,    90,   185,    28,    60,
      26,    65,    66,    42,    87,    88,    49,    16,    68,    47,
      49,    49,    67,    47,    49,    89,    47,    49,    12,    91,
      92,    49,     8,    74,    47,   185,    29,    65,   185,    43,
      87,    93,    47,    49,    69,    49,    15,    76,    27,    47,
      49,    49,    47,    49,    49,   185,    13,    91,     5,    70,
      71,    75,    49,     3,     7,    14,    17,    20,    30,    32,
      33,    34,    35,    37,    39,    40,    44,    45,    58,    98,
     102,   107,   112,   116,   125,   129,   133,   137,   141,   151,
     162,   166,   169,   173,    60,    47,    47,    49,    49,    72,
       6,    73,    49,    58,    77,   117,   136,   101,   142,   106,
     170,   111,   115,   174,   167,   152,   140,   132,   128,   163,
      49,    47,    42,    47,   185,   185,    47,    70,    49,    24,
      78,    80,   185,   185,   185,   185,   185,   185,   185,   185,
     185,   185,   185,   185,   185,   185,   185,    47,    26,    12,
      49,    49,    16,    47,    81,    23,    79,    83,    49,   118,
     134,   135,    99,   100,   143,   103,   105,   171,   108,   110,
     113,   114,   175,   168,   153,   138,   139,   130,   131,   126,
     127,   164,    31,    58,    58,    49,     8,   185,    84,    47,
      49,    78,    49,    49,    47,    49,    47,    49,    49,    47,
      49,    49,    47,    49,    47,    49,    49,    49,    49,    47,
      49,    47,    49,    47,    49,    48,    49,    49,    49,    49,
     185,    15,    79,    38,   178,   179,   180,   178,   178,   144,
     104,   178,   109,   178,   176,   178,   178,   178,   178,   178,
     178,    47,    47,    82,    49,    49,   181,     9,   119,   120,
      36,   182,   183,    49,    47,    47,   178,   178,   172,   178,
      11,    94,   178,   145,   146,   154,    47,    47,    47,   165,
       5,     6,    94,    85,   185,    49,    47,    49,   184,    49,
     179,     7,    14,    22,   147,    94,    80,    94,    49,    47,
     177,    47,    58,   155,   156,    39,    40,    44,    58,    49,
      58,    58,    47,    49,    18,   121,     3,   119,   185,   182,
     185,   145,    70,    49,    47,    10,    95,    96,    33,    86,
      35,    49,    25,   160,     4,   157,    49,    49,    49,    47,
     122,    49,    47,    49,    49,    47,    73,    78,    32,    97,
      47,    49,    90,   145,    49,    47,   158,    49,    47,    47,
      47,    38,   185,    41,   123,    47,    21,   148,   149,    17,
      74,    79,   185,    11,    95,    68,   161,    37,   185,   155,
      45,    24,    23,    47,    48,    49,   124,    49,    36,   150,
      47,    49,    47,    47,    47,    49,    49,    74,    58,    49,
      51,    47,   185,    47,   185,    22,   148,    20,    30,    47,
      76,    49,   159,    46,    18,    47,    49,     9,    47,    49,
      49,    10,    58,    47,    58,    47,    47,    47,    49,    25,
      49,    18,    41,    21,    47,    49,    47,    34,     4
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (0)


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (N)								\
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (0)
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
              (Loc).first_line, (Loc).first_column,	\
              (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr,					\
                  Type, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname[yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      size_t yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

#endif /* YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);


# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()
    ;
#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a look-ahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to look-ahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

    { currentSymTabEntryKey = symTab.insert(K_PROCESS);
    currentSymTabEntry = symTab.lookup(currentSymTabEntryKey); 
  }
    break;

  case 3:

    { //symTab.traceST(string((symTab.readAttribute(currentSymTabEntryKey, "name"))->value->name) + "\n");
      (dynamic_cast <STProcess*> (currentSymTabEntry))->abstractProcess = true;
      if((dynamic_cast <STProcess*> (currentSymTabEntry))->abstractProcess) symTab.traceST("TRUE\n");
      else  symTab.traceST("FALSE");
      
      att.check((yyvsp[0].yt_integer), K_PROCESS);
      if(att.isAttributeValueEmpty((yyvsp[0].yt_integer), "suppressJoinFailure"))
      {
      	/// default attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), mkcasestring("no"));
      }
      else
      {
        /// current BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), att.read((yyvsp[0].yt_integer), "suppressJoinFailure"));      
      }      
      symMan.initialiseProcessScope((yyvsp[0].yt_integer));
      currentScopeId = (yyvsp[0].yt_integer);
      isInFH.push(false);
      isInCH.push(pair<bool,int>(false,0));
      hasCompensate = 0;
   }
    break;

  case 4:

    { TheProcess = (yyval.yt_tProcess) = Process((yyvsp[-11].yt_tPartnerLink_list), (yyvsp[-10].yt_tPartner_list), (yyvsp[-9].yt_tVariable_list), (yyvsp[-8].yt_tCorrelationSet_list), (yyvsp[-7].yt_tFaultHandlers), (yyvsp[-6].yt_tCompensationHandler), (yyvsp[-5].yt_tEventHandlers), StopInProcess(), (yyvsp[-4].yt_activity));
      symMan.quitScope();
      (yyval.yt_tProcess)->name = att.read((yyvsp[-15].yt_integer), "name");
      (yyval.yt_tProcess)->targetNamespace = att.read((yyvsp[-15].yt_integer), "targetNamespace");
      (yyval.yt_tProcess)->queryLanguage = att.read((yyvsp[-15].yt_integer), "queryLanguage", (yyval.yt_tProcess)->queryLanguage);
      (yyval.yt_tProcess)->expressionLanguage = att.read((yyvsp[-15].yt_integer), "expressionLanguage", (yyval.yt_tProcess)->expressionLanguage);
      (yyval.yt_tProcess)->suppressJoinFailure = att.read((yyvsp[-15].yt_integer), "suppressJoinFailure", (yyval.yt_tProcess)->suppressJoinFailure);
      att.traceAM(string("tProcess: ") + ((yyval.yt_tProcess)->suppressJoinFailure)->name + string("\n"));      
      att.popSJFStack();
      (yyval.yt_tProcess)->enableInstanceCompensation = att.read((yyvsp[-15].yt_integer), "enableInstanceCompensation", (yyval.yt_tProcess)->enableInstanceCompensation);
      (yyval.yt_tProcess)->abstractProcess = att.read((yyvsp[-15].yt_integer), "abstractProcess", (yyval.yt_tProcess)->abstractProcess);
      (yyval.yt_tProcess)->xmlns = att.read((yyvsp[-15].yt_integer), "xmlns", (yyval.yt_tProcess)->xmlns);
      isInFH.pop();
      isInCH.pop();
      (yyval.yt_tProcess)->id = (yyvsp[-15].yt_integer);
      (yyval.yt_tProcess)->hasEH = (string((yyvsp[-5].yt_tEventHandlers)->op_name()) == "userDefinedEventHandler"); }
    break;

  case 7:

    { (yyval.yt_activity) = activityEmpty((yyvsp[0].yt_tEmpty)); (yyval.yt_activity)->id = (yyvsp[0].yt_tEmpty)->id; 
      (yyval.yt_activity)->negativeControlFlow = (yyvsp[0].yt_tEmpty)->negativeControlFlow; }
    break;

  case 8:

    { (yyval.yt_activity) = (yyvsp[0].yt_activity);  }
    break;

  case 9:

    { (yyval.yt_activity) = activityReceive((yyvsp[0].yt_tReceive)); (yyval.yt_activity)->id = (yyvsp[0].yt_tReceive)->id; 
      (yyval.yt_activity)->negativeControlFlow = (yyvsp[0].yt_tReceive)->negativeControlFlow; }
    break;

  case 10:

    { (yyval.yt_activity) = activityReply((yyvsp[0].yt_tReply)); (yyval.yt_activity)->id = (yyvsp[0].yt_tReply)->id; 
      (yyval.yt_activity)->negativeControlFlow = (yyvsp[0].yt_tReply)->negativeControlFlow; }
    break;

  case 11:

    { (yyval.yt_activity) = activityAssign((yyvsp[0].yt_tAssign)); (yyval.yt_activity)->id = (yyvsp[0].yt_tAssign)->id; 
      (yyval.yt_activity)->negativeControlFlow = (yyvsp[0].yt_tAssign)->negativeControlFlow; }
    break;

  case 12:

    { (yyval.yt_activity) = activityWait((yyvsp[0].yt_tWait)); (yyval.yt_activity)->id = (yyvsp[0].yt_tWait)->id; 
      (yyval.yt_activity)->negativeControlFlow = (yyvsp[0].yt_tWait)->negativeControlFlow; }
    break;

  case 13:

    { (yyval.yt_activity) = activityThrow((yyvsp[0].yt_tThrow)); (yyval.yt_activity)->id = (yyvsp[0].yt_tThrow)->id; 
      (yyval.yt_activity)->negativeControlFlow = (yyvsp[0].yt_tThrow)->negativeControlFlow; }
    break;

  case 14:

    { (yyval.yt_activity) = activityTerminate((yyvsp[0].yt_tTerminate)); (yyval.yt_activity)->id = (yyvsp[0].yt_tTerminate)->id; 
      (yyval.yt_activity)->negativeControlFlow = (yyvsp[0].yt_tTerminate)->negativeControlFlow; }
    break;

  case 15:

    { (yyval.yt_activity) = activityFlow((yyvsp[0].yt_tFlow)); (yyval.yt_activity)->id = (yyvsp[0].yt_tFlow)->id; 
      (yyval.yt_activity)->dpe = (yyvsp[0].yt_tFlow)->dpe ;
      (yyval.yt_activity)->negativeControlFlow = (yyvsp[0].yt_tFlow)->negativeControlFlow; }
    break;

  case 16:

    { (yyval.yt_activity) = activitySwitch((yyvsp[0].yt_tSwitch)); (yyval.yt_activity)->id = (yyvsp[0].yt_tSwitch)->id; 
      (yyval.yt_activity)->dpe = (yyvsp[0].yt_tSwitch)->dpe;
      (yyval.yt_activity)->negativeControlFlow = (yyvsp[0].yt_tSwitch)->negativeControlFlow; }
    break;

  case 17:

    { (yyval.yt_activity) = activityWhile((yyvsp[0].yt_tWhile)); (yyval.yt_activity)->id = (yyvsp[0].yt_tWhile)->id; 
      (yyval.yt_activity)->negativeControlFlow = (yyvsp[0].yt_tWhile)->negativeControlFlow; }
    break;

  case 18:

    { (yyval.yt_activity) = activitySequence((yyvsp[0].yt_tSequence)); (yyval.yt_activity)->id = (yyvsp[0].yt_tSequence)->id; 
      (yyval.yt_activity)->dpe = (yyvsp[0].yt_tSequence)->dpe;
      (yyval.yt_activity)->negativeControlFlow = (yyvsp[0].yt_tSequence)->negativeControlFlow; }
    break;

  case 19:

    { (yyval.yt_activity) = activityPick((yyvsp[0].yt_tPick)); (yyval.yt_activity)->id = (yyvsp[0].yt_tPick)->id; 
      (yyval.yt_activity)->dpe = (yyvsp[0].yt_tPick)->dpe;
      (yyval.yt_activity)->negativeControlFlow = (yyvsp[0].yt_tPick)->negativeControlFlow; }
    break;

  case 20:

    { (yyval.yt_activity) = activityScope((yyvsp[0].yt_tScope)); (yyval.yt_activity)->id = (yyvsp[0].yt_tScope)->id; 
      (yyval.yt_activity)->dpe = (yyvsp[0].yt_tScope)->dpe;
      (yyval.yt_activity)->negativeControlFlow = (yyvsp[0].yt_tScope)->negativeControlFlow; }
    break;

  case 21:

    { (yyval.yt_activity) = activityCompensate((yyvsp[0].yt_tCompensate)); (yyval.yt_activity)->id = (yyvsp[0].yt_tCompensate)->id; 
      (yyval.yt_activity)->negativeControlFlow = (yyvsp[0].yt_tCompensate)->negativeControlFlow; }
    break;

  case 22:

    { (yyval.yt_tPartnerLink_list) = NiltPartnerLink_list(); }
    break;

  case 23:

    { (yyval.yt_tPartnerLink_list) = (yyvsp[-3].yt_tPartnerLink_list); }
    break;

  case 24:

    { (yyval.yt_tPartnerLink_list) = ConstPartnerLink_list((yyvsp[-1].yt_tPartnerLink), NiltPartnerLink_list()); }
    break;

  case 25:

    { (yyval.yt_tPartnerLink_list) = ConstPartnerLink_list((yyvsp[-2].yt_tPartnerLink), (yyvsp[0].yt_tPartnerLink_list)); }
    break;

  case 26:

    { (yyval.yt_tPartnerLink) = PartnerLink();
      (yyval.yt_tPartnerLink)->name = att.read((yyvsp[-3].yt_integer), "name");
      (yyval.yt_tPartnerLink)->partnerLinkType = att.read((yyvsp[-3].yt_integer), "partnerLinkType");
      (yyval.yt_tPartnerLink)->myRole = att.read((yyvsp[-3].yt_integer), "myRole");
      (yyval.yt_tPartnerLink)->partnerRole = att.read((yyvsp[-3].yt_integer), "partnerRole"); 
      if (inPartners) {
        symMan.checkPartnerLink((yyval.yt_tPartnerLink)->name->name);
      }
      else
      {
        symMan.addPartnerLink(new csPartnerLink((yyval.yt_tPartnerLink)->name->name, (yyval.yt_tPartnerLink)->partnerLinkType->name, 
	  		                        (yyval.yt_tPartnerLink)->myRole->name, (yyval.yt_tPartnerLink)->partnerRole->name)); 
      }
    }
    break;

  case 27:

    { (yyval.yt_tPartnerLink) = PartnerLink();
      (yyval.yt_tPartnerLink)->name = att.read((yyvsp[-1].yt_integer), "name");
      (yyval.yt_tPartnerLink)->partnerLinkType = att.read((yyvsp[-1].yt_integer), "partnerLinkType");
      (yyval.yt_tPartnerLink)->myRole = att.read((yyvsp[-1].yt_integer), "myRole");
      (yyval.yt_tPartnerLink)->partnerRole = att.read((yyvsp[-1].yt_integer), "partnerRole");
      if (inPartners) {
        symMan.checkPartnerLink((yyval.yt_tPartnerLink)->name->name);
      }
      else
      {
        symMan.addPartnerLink(new csPartnerLink((yyval.yt_tPartnerLink)->name->name, (yyval.yt_tPartnerLink)->partnerLinkType->name, 
	  		                        (yyval.yt_tPartnerLink)->myRole->name, (yyval.yt_tPartnerLink)->partnerRole->name)); 
      }
    }
    break;

  case 28:

    { currentSymTabEntryKey = symTab.insert(K_PARTNERLINK);
    currentSymTabEntry = symTab.lookup(currentSymTabEntryKey); 
  }
    break;

  case 29:

    { (yyval.yt_tPartner_list) = NiltPartner_list(); }
    break;

  case 30:

    { inPartners = true; }
    break;

  case 31:

    { (yyval.yt_tPartner_list) = (yyvsp[-3].yt_tPartner_list);
      inPartners = false; }
    break;

  case 32:

    { (yyval.yt_tPartner_list) = ConstPartner_list((yyvsp[-1].yt_tPartner), NiltPartner_list()); }
    break;

  case 33:

    { (yyval.yt_tPartner_list) = ConstPartner_list((yyvsp[-2].yt_tPartner), (yyvsp[0].yt_tPartner_list)); }
    break;

  case 34:

    { (yyval.yt_tPartner) = Partner((yyvsp[-2].yt_tPartnerLink_list));
      (yyval.yt_tPartner)->name = att.read((yyvsp[-4].yt_integer), "name"); }
    break;

  case 35:

    { (yyval.yt_tPartner) = Partner(NiltPartnerLink_list());
      (yyval.yt_tPartner)->name = att.read((yyvsp[-1].yt_integer), "name"); }
    break;

  case 36:

    { currentSymTabEntryKey = symTab.insert(K_PARTNER);
    currentSymTabEntry = symTab.lookup(currentSymTabEntryKey); 
  }
    break;

  case 37:

    { (yyval.yt_tFaultHandlers) = implicitFaultHandler();
      (yyval.yt_tFaultHandlers)->inProcess = (currentScopeId->value == 1);
      (yyval.yt_tFaultHandlers)->parentScopeId = currentScopeId; 
      (yyval.yt_tFaultHandlers)->hasCatchAll = false;
    }
    break;

  case 38:

    {
      symMan.startDPEinWhile();
      isInFH.push(true);
      hasCompensate = 0;
    }
    break;

  case 39:

    { (yyval.yt_tFaultHandlers) = userDefinedFaultHandler((yyvsp[-4].yt_tCatch_list), (yyvsp[-3].yt_tCatchAll));
      (yyval.yt_tFaultHandlers)->inProcess = (currentScopeId->value == 1);
      (yyval.yt_tFaultHandlers)->parentScopeId = currentScopeId;
      (yyval.yt_tFaultHandlers)->hasCatchAll = hasCatchAll;
      isInFH.pop();
      hasCompensate = 0;
      symMan.endDPEinWhile();
    }
    break;

  case 40:

    { (yyval.yt_tCatch_list) = NiltCatch_list(); }
    break;

  case 41:

    { (yyval.yt_tCatch_list) = ConstCatch_list((yyvsp[-2].yt_tCatch), (yyvsp[0].yt_tCatch_list)); }
    break;

  case 42:

    { currentSymTabEntryKey = symTab.insert(K_CATCH);
    currentSymTabEntry = symTab.lookup(currentSymTabEntryKey); 
  }
    break;

  case 43:

    { (yyval.yt_tCatch) = Catch((yyvsp[-3].yt_activity));
      (yyval.yt_tCatch)->faultName = att.read((yyvsp[-5].yt_integer), "faultName");
      (yyval.yt_tCatch)->faultVariable = att.read((yyvsp[-5].yt_integer), "faultVariable"); 
      (yyval.yt_tCatch)->variableID = symMan.checkVariable(att.read((yyvsp[-5].yt_integer), "faultVariable")->name, true); 
    }
    break;

  case 44:

    { hasCatchAll = false;
      (yyval.yt_tCatchAll) = NoCatchAll(); }
    break;

  case 45:

    { hasCatchAll = true;
      (yyval.yt_tCatchAll) = CatchAll((yyvsp[-4].yt_activity));
      (yyval.yt_tCatchAll)->faultName = att.read((yyvsp[-6].yt_integer), "faultName");
      (yyval.yt_tCatchAll)->faultVariable = att.read((yyvsp[-6].yt_integer), "faultVariable");
      // $$->variableID = symMan.checkVariable(att.read($2, "faultVariable")->name, true); 
    }
    break;

  case 46:

    { if (currentScopeId->value == 1)
        (yyval.yt_tCompensationHandler) = processCompensationHandler();
      else
        (yyval.yt_tCompensationHandler) = implicitCompensationHandler();
      (yyval.yt_tCompensationHandler)->parentScopeId = currentScopeId; }
    break;

  case 47:

    {
      symMan.startDPEinWhile();
      isInCH.push(pair<bool,int>(true,hasCompensate));
      hasCompensate = 0;
    }
    break;

  case 48:

    { if (currentScopeId->value == 1)
        (yyval.yt_tCompensationHandler) = processCompensationHandler();
      else
        (yyval.yt_tCompensationHandler) = userDefinedCompensationHandler((yyvsp[-4].yt_activity));

      switch ( hasCompensate ) {
        case 1 : (yyval.yt_tCompensationHandler)->compensateWithoutScope = true;
                 (yyval.yt_tCompensationHandler)->compensateWithScope = false;
                 break;
        case 2 : (yyval.yt_tCompensationHandler)->compensateWithoutScope = false;
                 (yyval.yt_tCompensationHandler)->compensateWithScope = true;
                 break;
        default: (yyval.yt_tCompensationHandler)->compensateWithoutScope = false;
                 (yyval.yt_tCompensationHandler)->compensateWithScope = false;
                 break;
      }
      hasCompensate = isInCH.top().second;
      isInCH.pop();

      (yyval.yt_tCompensationHandler)->parentScopeId = currentScopeId; 
      symMan.endDPEinWhile();
    }
    break;

  case 49:

    { (yyval.yt_tEventHandlers) = implicitEventHandler();
      (yyval.yt_tEventHandlers)->parentScopeId = currentScopeId; }
    break;

  case 50:

    {
      symMan.startDPEinWhile();
    }
    break;

  case 51:

    { (yyval.yt_tEventHandlers) = userDefinedEventHandler((yyvsp[-4].yt_tOnMessage_list), (yyvsp[-3].yt_tOnAlarm_list));
      (yyval.yt_tEventHandlers)->parentScopeId = currentScopeId; 
      symMan.endDPEinWhile();
    }
    break;

  case 52:

    { (yyval.yt_tOnMessage_list) = NiltOnMessage_list(); 
      (yyval.yt_tOnMessage_list)->dpe = kc::mkinteger(0);
    }
    break;

  case 53:

    { (yyval.yt_tOnMessage_list) = ConstOnMessage_list((yyvsp[-2].yt_tOnMessage), (yyvsp[0].yt_tOnMessage_list)); 
      (yyval.yt_tOnMessage_list)->dpe = kc::mkinteger((yyvsp[-2].yt_tOnMessage)->dpe->value + (yyvsp[0].yt_tOnMessage_list)->dpe->value);
    }
    break;

  case 54:

    { (yyval.yt_tOnAlarm_list) = NiltOnAlarm_list(); 
      (yyval.yt_tOnAlarm_list)->dpe = kc::mkinteger(0);
    }
    break;

  case 55:

    { (yyval.yt_tOnAlarm_list) = ConstOnAlarm_list((yyvsp[-2].yt_tOnAlarm), (yyvsp[0].yt_tOnAlarm_list)); 
      (yyval.yt_tOnAlarm_list)->dpe = kc::mkinteger((yyvsp[-2].yt_tOnAlarm)->dpe->value + (yyvsp[0].yt_tOnAlarm_list)->dpe->value);
    }
    break;

  case 56:

    { currentSymTabEntryKey = symTab.insert(K_ONMESSAGE);
    currentSymTabEntry = symTab.lookup(currentSymTabEntryKey); 
  }
    break;

  case 57:

    {
      symMan.checkPartnerLink(att.read((yyvsp[-1].yt_integer), "partnerLink")->name);
      symMan.resetDPEend();
    }
    break;

  case 58:

    { att.check((yyvsp[-7].yt_integer), K_ONMESSAGE);
      (yyval.yt_tOnMessage) = OnMessage((yyvsp[-3].yt_activity));
      (yyval.yt_tOnMessage)->partnerLink = att.read((yyvsp[-7].yt_integer), "partnerLink");
      (yyval.yt_tOnMessage)->portType = att.read((yyvsp[-7].yt_integer), "portType");
      (yyval.yt_tOnMessage)->operation = att.read((yyvsp[-7].yt_integer), "operation");
      (yyval.yt_tOnMessage)->variableID  = symMan.checkVariable(att.read((yyvsp[-7].yt_integer), "variable")->name);
      (yyval.yt_tOnMessage)->variable = att.read((yyvsp[-7].yt_integer), "variable"); 
      (yyval.yt_tOnMessage)->channelID = symMan.addChannel(new csChannel((yyval.yt_tOnMessage)->portType->name, 
				      (yyval.yt_tOnMessage)->operation->name, 
				      (yyval.yt_tOnMessage)->partnerLink->name), true); 
      (yyval.yt_tOnMessage)->dpe = symMan.needsDPE();
    }
    break;

  case 59:

    { currentSymTabEntryKey = symTab.insert(K_ONALARM);
    currentSymTabEntry = symTab.lookup(currentSymTabEntryKey); 
  }
    break;

  case 60:

    {
      symMan.resetDPEend();
    }
    break;

  case 61:

    { att.check((yyvsp[-6].yt_integer), K_ONALARM);
      (yyval.yt_tOnAlarm) = OnAlarm((yyvsp[-3].yt_activity));
      (yyval.yt_tOnAlarm)->For = att.read((yyvsp[-6].yt_integer), "for");  // "for" is a keyword
      (yyval.yt_tOnAlarm)->until = att.read((yyvsp[-6].yt_integer), "until");
      (yyval.yt_tOnAlarm)->dpe = symMan.needsDPE();
    }
    break;

  case 62:

    { (yyval.yt_tVariable_list) = NiltVariable_list(); }
    break;

  case 63:

    { (yyval.yt_tVariable_list) = (yyvsp[-3].yt_tVariable_list); }
    break;

  case 64:

    { (yyval.yt_tVariable_list) = ConstVariable_list((yyvsp[-1].yt_tVariable), NiltVariable_list()); }
    break;

  case 65:

    { (yyval.yt_tVariable_list) = ConstVariable_list((yyvsp[-2].yt_tVariable), (yyvsp[0].yt_tVariable_list)); }
    break;

  case 66:

    { (yyval.yt_tVariable) = Variable();
      (yyval.yt_tVariable)->name = att.read((yyvsp[-3].yt_integer), "name");
      (yyval.yt_tVariable)->messageType = att.read((yyvsp[-3].yt_integer), "messageType");
      (yyval.yt_tVariable)->type = att.read((yyvsp[-3].yt_integer), "type");
      (yyval.yt_tVariable)->element = att.read((yyvsp[-3].yt_integer), "element"); 
      (yyval.yt_tVariable)->variableID = symMan.addVariable( 
	              new csVariable((yyval.yt_tVariable)->name->name, 
				     (yyval.yt_tVariable)->messageType->name, 
				     (yyval.yt_tVariable)->type->name, 
				     (yyval.yt_tVariable)->element->name)); }
    break;

  case 67:

    { (yyval.yt_tVariable) = Variable();
      (yyval.yt_tVariable)->name = att.read((yyvsp[-1].yt_integer), "name");
      (yyval.yt_tVariable)->messageType = att.read((yyvsp[-1].yt_integer), "messageType");
      (yyval.yt_tVariable)->type = att.read((yyvsp[-1].yt_integer), "type");
      (yyval.yt_tVariable)->element = att.read((yyvsp[-1].yt_integer), "element"); 
      (yyval.yt_tVariable)->variableID = symMan.addVariable( 
	              new csVariable((yyval.yt_tVariable)->name->name, 
				     (yyval.yt_tVariable)->messageType->name, 
				     (yyval.yt_tVariable)->type->name, 
				     (yyval.yt_tVariable)->element->name)); }
    break;

  case 68:

    { currentSymTabEntryKey = symTab.insert(K_VARIABLE);
    currentSymTabEntry = symTab.lookup(currentSymTabEntryKey); 
  }
    break;

  case 69:

    { (yyval.yt_tCorrelationSet_list) = NiltCorrelationSet_list(); }
    break;

  case 70:

    { (yyval.yt_tCorrelationSet_list) = (yyvsp[-3].yt_tCorrelationSet_list); }
    break;

  case 71:

    { (yyval.yt_tCorrelationSet_list) = ConstCorrelationSet_list((yyvsp[-1].yt_tCorrelationSet), NiltCorrelationSet_list()); }
    break;

  case 72:

    { (yyval.yt_tCorrelationSet_list) = ConstCorrelationSet_list((yyvsp[-2].yt_tCorrelationSet), (yyvsp[0].yt_tCorrelationSet_list)); }
    break;

  case 73:

    { (yyval.yt_tCorrelationSet) = CorrelationSet(); }
    break;

  case 74:

    { (yyval.yt_tCorrelationSet) = CorrelationSet();
      (yyval.yt_tCorrelationSet)->properties = att.read((yyvsp[-1].yt_integer), "properties");
      (yyval.yt_tCorrelationSet)->name = att.read((yyvsp[-1].yt_integer), "name"); }
    break;

  case 75:

    { currentSymTabEntryKey = symTab.insert(K_CORRELATIONSET);
    currentSymTabEntry = symTab.lookup(currentSymTabEntryKey); 
  }
    break;

  case 76:

    { (yyval.yt_tCorrelation_list) = NiltCorrelation_list(); }
    break;

  case 77:

    { (yyval.yt_tCorrelation_list) = (yyvsp[-3].yt_tCorrelation_list); }
    break;

  case 78:

    { (yyval.yt_tCorrelation_list) = ConstCorrelation_list((yyvsp[-1].yt_tCorrelation), NiltCorrelation_list());
      if ((yyvsp[-1].yt_tCorrelation)->initiate = mkcasestring("yes"))
        (yyval.yt_tCorrelation_list)->initiateCorrelationSet = true; }
    break;

  case 79:

    { (yyval.yt_tCorrelation_list) = ConstCorrelation_list((yyvsp[-2].yt_tCorrelation), (yyvsp[0].yt_tCorrelation_list));
      if ((yyvsp[-2].yt_tCorrelation)->initiate = mkcasestring("yes"))
        (yyval.yt_tCorrelation_list)->initiateCorrelationSet = true; }
    break;

  case 80:

    { (yyval.yt_tCorrelation) = Correlation();
      (yyval.yt_tCorrelation)->set = att.read((yyvsp[-3].yt_integer), "set");
      (yyval.yt_tCorrelation)->initiate = att.read((yyvsp[-3].yt_integer), "initiate", (yyval.yt_tCorrelation)->initiate);
      (yyval.yt_tCorrelation)->pattern = att.read((yyvsp[-3].yt_integer), "pattern"); }
    break;

  case 81:

    { (yyval.yt_tCorrelation) = Correlation();
      (yyval.yt_tCorrelation)->set = att.read((yyvsp[-1].yt_integer), "set");
      (yyval.yt_tCorrelation)->initiate = att.read((yyvsp[-1].yt_integer), "initiate", (yyval.yt_tCorrelation)->initiate);
      (yyval.yt_tCorrelation)->pattern = att.read((yyvsp[-1].yt_integer), "pattern"); }
    break;

  case 82:

    { currentSymTabEntryKey = symTab.insert(K_CORRELATION);
    currentSymTabEntry = symTab.lookup(currentSymTabEntryKey); 
  }
    break;

  case 83:

    { 
      att.check((yyvsp[0].yt_integer), K_EMPTY);
      if(att.isAttributeValueEmpty((yyvsp[0].yt_integer), "suppressJoinFailure"))
      {
      	/// parent BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), (att.topSJFStack()).getSJFValue());
      }
      else
      {
        /// current BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), att.read((yyvsp[0].yt_integer), "suppressJoinFailure"));      
      }
    }
    break;

  case 84:

    { (yyval.yt_tEmpty) = Empty((yyvsp[-2].yt_standardElements));
      (yyval.yt_tEmpty)->name = att.read((yyvsp[-5].yt_integer), "name");
      (yyval.yt_tEmpty)->joinCondition = (yyvsp[-2].yt_standardElements)->joinCondition = att.read((yyvsp[-5].yt_integer), "joinCondition");
      att.traceAM(string("tEmpty: ") + (att.read((yyvsp[-5].yt_integer), "suppressJoinFailure"))->name + string("\n"));
      (yyval.yt_tEmpty)->suppressJoinFailure = (yyvsp[-2].yt_standardElements)->suppressJoinFailure = att.read((yyvsp[-5].yt_integer), "suppressJoinFailure",  (att.topSJFStack()).getSJFValue());
      att.traceAM(string("tEmpty: ") + ((yyval.yt_tEmpty)->suppressJoinFailure)->name + string("\n"));
      att.popSJFStack();
      (yyval.yt_tEmpty)->negativeControlFlow = (yyvsp[-2].yt_standardElements)->negativeControlFlow = mkinteger( ((int) isInFH.top()) + 2*((int) isInCH.top().first));
      (yyval.yt_tEmpty)->id = (yyvsp[-2].yt_standardElements)->parentId = (yyvsp[-5].yt_integer); 
      if ((yyvsp[-2].yt_standardElements)->hasTarget)
      {
	symMan.remDPEstart();
      }
      if ((yyvsp[-2].yt_standardElements)->dpe->value > 0)
      {
        symMan.addDPEend();
      }
    }
    break;

  case 85:

    { 
      att.check((yyvsp[0].yt_integer), K_EMPTY);
      if(att.isAttributeValueEmpty((yyvsp[0].yt_integer), "suppressJoinFailure"))
      {
      	/// parent BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), (att.topSJFStack()).getSJFValue());
      }
      else
      {
        /// current BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), att.read((yyvsp[0].yt_integer), "suppressJoinFailure"));      
      }
    }
    break;

  case 86:

    { impl_standardElements_StandardElements *noLinks = StandardElements(NiltTarget_list(), NiltSource_list());
      noLinks->parentId = (yyvsp[-2].yt_integer);
      (yyval.yt_tEmpty) = Empty(noLinks);
      (yyval.yt_tEmpty)->name = att.read((yyvsp[-2].yt_integer), "name");
      (yyval.yt_tEmpty)->joinCondition = att.read((yyvsp[-2].yt_integer), "joinCondition");
      (yyval.yt_tEmpty)->suppressJoinFailure = att.read((yyvsp[-2].yt_integer), "suppressJoinFailure",  (att.topSJFStack()).getSJFValue());
      att.traceAM(string("tEmpty: ") + ((yyval.yt_tEmpty)->suppressJoinFailure)->name + string("\n"));
      att.popSJFStack();
      (yyval.yt_tEmpty)->negativeControlFlow = noLinks->negativeControlFlow = mkinteger( ((int) isInFH.top()) + 2*((int) isInCH.top().first));
      (yyval.yt_tEmpty)->id = (yyvsp[-2].yt_integer); }
    break;

  case 87:

    { currentSymTabEntryKey = symTab.insert(K_EMPTY);
    currentSymTabEntry = symTab.lookup(currentSymTabEntryKey); 
  }
    break;

  case 88:

    { 
      att.check((yyvsp[0].yt_integer), K_INVOKE);
      if(att.isAttributeValueEmpty((yyvsp[0].yt_integer), "suppressJoinFailure"))
      {
      	/// parent BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), (att.topSJFStack()).getSJFValue());
      }
      else
      {
        /// current BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), att.read((yyvsp[0].yt_integer), "suppressJoinFailure"));      
      }
    }
    break;

  case 89:

    {
      // automatically create scope?
      symMan.checkPartnerLink(att.read((yyvsp[-2].yt_integer), "partnerLink")->name);
      isInFH.push(false);
      isInCH.push(pair<bool,int>(false,hasCompensate));
      parent[(yyvsp[-2].yt_integer)] = currentScopeId;
      kc::integer qad_id = att.nextId();
      parent[qad_id] = currentScopeId;
      currentScopeId = qad_id; 
    }
    break;

  case 90:

    { 
      isInFH.pop();
      hasCompensate = isInCH.top().second;
      isInCH.pop();
      if ((yyvsp[-4].yt_tCatch_list)->length() > 0 
           || (string((yyvsp[-3].yt_tCatchAll)->op_name()) != "NoCatchAll") 
           || string((yyvsp[-2].yt_tCompensationHandler)->op_name()) != "implicitCompensationHandler")
      {
        //cerr << "embed in scope" << endl;
        standardElements se =  StandardElements(NiltTarget_list(), NiltSource_list());
        tInvoke invoke = Invoke(se, (yyvsp[-5].yt_tCorrelation_list));
        activity ai = activityInvoke(invoke);
        tFaultHandlers fh = userDefinedFaultHandler((yyvsp[-4].yt_tCatch_list), (yyvsp[-3].yt_tCatchAll));
        fh->hasCatchAll = hasCatchAll;
        tEventHandlers eh = implicitEventHandler();
        tScope scope = Scope((yyvsp[-6].yt_standardElements), NiltVariable_list(), fh, (yyvsp[-2].yt_tCompensationHandler), eh, StopInScope(), ai);

        scope->id = (yyvsp[-6].yt_standardElements)->parentId = currentScopeId; 
        invoke->id = ai->id = se->parentId = (yyvsp[-10].yt_integer);

        fh->inProcess = false;
        fh->parentScopeId = scope->id;
        (yyvsp[-2].yt_tCompensationHandler)->parentScopeId = scope->id;
        eh->parentScopeId = scope->id;

        symMan.newScopeScope(scope->id);
        symMan.quitScope();

	invoke->name = att.read((yyvsp[-10].yt_integer), "name");

        currentSymTabEntryKey = symTab.insert(K_SCOPE);
        currentSymTabEntry = symTab.lookup(currentSymTabEntryKey); 
	symTab.setMapping(currentSymTabEntryKey, scope->id);
		
		
        scope->name = att.read((yyvsp[-10].yt_integer), "name");
        symTab.addAttribute(currentSymTabEntryKey, symTab.newAttribute(mkcasestring("name"), scope->name));
        scope->joinCondition = invoke->joinCondition = (yyvsp[-6].yt_standardElements)->joinCondition = att.read((yyvsp[-10].yt_integer), "joinCondition");
        symTab.addAttribute(currentSymTabEntryKey, symTab.newAttribute(mkcasestring("joinCondition"), scope->joinCondition));
        scope->suppressJoinFailure = invoke->suppressJoinFailure = (yyvsp[-6].yt_standardElements)->suppressJoinFailure = att.read((yyvsp[-10].yt_integer), "suppressJoinFailure",  (att.topSJFStack()).getSJFValue());
        symTab.addAttribute(currentSymTabEntryKey, symTab.newAttribute(mkcasestring("suppressJoinFailure"), scope->suppressJoinFailure));
        scope->variableAccessSerializable = mkcasestring("");
        att.traceAM(string("tInvoke: ") + (invoke->suppressJoinFailure)->name + string("\n"));
	att.popSJFStack();
	invoke->partnerLink = att.read((yyvsp[-10].yt_integer), "partnerLink");
        invoke->portType = att.read((yyvsp[-10].yt_integer), "portType");
        invoke->operation = att.read((yyvsp[-10].yt_integer), "operation");
        invoke->inputVariable = att.read((yyvsp[-10].yt_integer), "inputVariable");
        invoke->outputVariable = att.read((yyvsp[-10].yt_integer), "outputVariable");
	// inputVariable <=> input for invoke process !!!
        invoke->variableIDin  = symMan.checkVariable(att.read((yyvsp[-10].yt_integer), "inputVariable")->name);
        invoke->variableIDout = symMan.checkVariable(att.read((yyvsp[-10].yt_integer), "outputVariable")->name);
        if (string(invoke->variableIDin->name) != "")
        {
          invoke->channelID = symMan.addChannel(new csChannel(invoke->portType->name, 
					  invoke->operation->name, 
					  invoke->partnerLink->name), false);
        }
        if (string(invoke->variableIDout->name) != "")
        {
          invoke->channelID = symMan.addChannel(new csChannel(invoke->portType->name, 
					  invoke->operation->name, 
					  invoke->partnerLink->name), true);
        }
	scope->dpe = invoke->dpe = mkinteger(0);
        // symMan.needsDPE();
        if ((yyvsp[-6].yt_standardElements)->hasTarget)
        {
	 symMan.remDPEstart();
	}
	if ((yyvsp[-6].yt_standardElements)->dpe->value > 0)
        {
          symMan.addDPEend();
        }
        scope->negativeControlFlow = mkinteger( ((int) isInFH.top()) + 2*((int) isInCH.top().first));
        invoke->negativeControlFlow = mkinteger(0);
        /*
        scope->id = $7->parentId = $3; 
        invoke->id = ai->id = se->parentId = att.nextId();
        */
        scope->hasEH = false;
        currentScopeId = scope->parentScopeId = parent[(yyvsp[-10].yt_integer)];

        (yyval.yt_activity) = activity(activityScope(scope));

        (yyval.yt_activity)->id = scope->id;
        (yyval.yt_activity)->negativeControlFlow = scope->negativeControlFlow;
      }
      else
      { 
        //cerr << "don't embed" << endl;

        //restore real scope ID
        currentScopeId = parent[(yyvsp[-10].yt_integer)];

        tInvoke invoke = Invoke((yyvsp[-6].yt_standardElements), (yyvsp[-5].yt_tCorrelation_list));

	invoke->name = att.read((yyvsp[-10].yt_integer), "name");
        invoke->joinCondition = (yyvsp[-6].yt_standardElements)->joinCondition = att.read((yyvsp[-10].yt_integer), "joinCondition");
        invoke->suppressJoinFailure = (yyvsp[-6].yt_standardElements)->suppressJoinFailure = att.read((yyvsp[-10].yt_integer), "suppressJoinFailure",  (att.topSJFStack()).getSJFValue());
        att.traceAM(string("tInvoke: ") + (invoke->suppressJoinFailure)->name + string("\n"));
        att.popSJFStack();
        invoke->partnerLink = att.read((yyvsp[-10].yt_integer), "partnerLink");
        invoke->portType = att.read((yyvsp[-10].yt_integer), "portType");
        invoke->operation = att.read((yyvsp[-10].yt_integer), "operation");
        invoke->inputVariable = att.read((yyvsp[-10].yt_integer), "inputVariable");
        invoke->outputVariable = att.read((yyvsp[-10].yt_integer), "outputVariable");
	// inputVariable <=> input for invoke process !!!
        invoke->variableIDin  = symMan.checkVariable(att.read((yyvsp[-10].yt_integer), "inputVariable")->name);
        invoke->variableIDout = symMan.checkVariable(att.read((yyvsp[-10].yt_integer), "outputVariable")->name);
        if (string(invoke->variableIDin->name) != "")
        {
          invoke->channelID = symMan.addChannel(new csChannel(invoke->portType->name, 
					  invoke->operation->name, 
					  invoke->partnerLink->name), false);
        }
        if (string(invoke->variableIDout->name) != "")
        {
          invoke->channelID = symMan.addChannel(new csChannel(invoke->portType->name, 
					  invoke->operation->name, 
					  invoke->partnerLink->name), true);
        }
        invoke->dpe = symMan.needsDPE();
        if ((yyvsp[-6].yt_standardElements)->hasTarget)
        {
	  symMan.remDPEstart();
	}
        if ((yyvsp[-6].yt_standardElements)->dpe->value > 0)
        {
          symMan.addDPEend();
        }
        invoke->negativeControlFlow = mkinteger( ((int) isInFH.top()) + 2*((int) isInCH.top().first));
        invoke->id = (yyvsp[-6].yt_standardElements)->parentId = (yyvsp[-10].yt_integer); 

        (yyval.yt_activity) = activity(activityInvoke(invoke));
        (yyval.yt_activity)->id = invoke->id;
        (yyval.yt_activity)->negativeControlFlow = invoke->negativeControlFlow;
      }    
    }
    break;

  case 91:

    { 
      att.check((yyvsp[0].yt_integer), K_INVOKE);
      if(att.isAttributeValueEmpty((yyvsp[0].yt_integer), "suppressJoinFailure"))
      {
      	/// parent BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), (att.topSJFStack()).getSJFValue());
      }
      else
      {
        /// current BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), att.read((yyvsp[0].yt_integer), "suppressJoinFailure"));      
      }
    }
    break;

  case 92:

    { 
      impl_standardElements_StandardElements *noLinks = StandardElements(NiltTarget_list(), NiltSource_list());
      noLinks->parentId = (yyvsp[-2].yt_integer);
      tInvoke invoke = Invoke(noLinks, NiltCorrelation_list());
      invoke->name = att.read((yyvsp[-2].yt_integer), "name");
      invoke->joinCondition = att.read((yyvsp[-2].yt_integer), "joinCondition");    
      invoke->suppressJoinFailure = att.read((yyvsp[-2].yt_integer), "suppressJoinFailure",  (att.topSJFStack()).getSJFValue());
      att.traceAM(string("tInvoke: ") + (invoke->suppressJoinFailure)->name + string("\n"));
      att.popSJFStack();
      invoke->partnerLink = att.read((yyvsp[-2].yt_integer), "partnerLink");
      invoke->portType = att.read((yyvsp[-2].yt_integer), "portType");
      invoke->operation = att.read((yyvsp[-2].yt_integer), "operation");
      invoke->inputVariable = att.read((yyvsp[-2].yt_integer), "inputVariable");
      invoke->outputVariable = att.read((yyvsp[-2].yt_integer), "outputVariable"); 
      // inputVariable <=> input for invoke process !!!
      invoke->variableIDin  = symMan.checkVariable(att.read((yyvsp[-2].yt_integer), "inputVariable")->name);
      invoke->variableIDout = symMan.checkVariable(att.read((yyvsp[-2].yt_integer), "outputVariable")->name);
      symMan.checkPartnerLink(invoke->partnerLink->name); 
      if (string(invoke->variableIDin->name) != "")
      {
        invoke->channelID = symMan.addChannel(new csChannel(invoke->portType->name, 
					invoke->operation->name, 
					invoke->partnerLink->name), false);
      }
      if (string(invoke->variableIDout->name) != "")
      {
        invoke->channelID = symMan.addChannel(new csChannel(invoke->portType->name, 
					invoke->operation->name, 
					invoke->partnerLink->name), true);
      }
      invoke->dpe = kc::mkinteger(0);
      invoke->negativeControlFlow = mkinteger( ((int) isInFH.top()) + 2*((int) isInCH.top().first));
      invoke->id = (yyvsp[-2].yt_integer); 

      (yyval.yt_activity) = activity(activityInvoke(invoke));
      (yyval.yt_activity)->id = invoke->id;
      (yyval.yt_activity)->negativeControlFlow = invoke->negativeControlFlow;
}
    break;

  case 93:

    { currentSymTabEntryKey = symTab.insert(K_INVOKE);
    currentSymTabEntry = symTab.lookup(currentSymTabEntryKey); 
  }
    break;

  case 94:

    { 
      att.check((yyvsp[0].yt_integer), K_RECEIVE);
      if(att.isAttributeValueEmpty((yyvsp[0].yt_integer), "suppressJoinFailure"))
      {
      	/// parent BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), (att.topSJFStack()).getSJFValue());
      }
      else
      {
        /// current BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), att.read((yyvsp[0].yt_integer), "suppressJoinFailure"));      
      }
    }
    break;

  case 95:

    { symMan.checkPartnerLink(att.read((yyvsp[-2].yt_integer), "partnerLink")->name); }
    break;

  case 96:

    { (yyval.yt_tReceive) = Receive((yyvsp[-3].yt_standardElements), (yyvsp[-2].yt_tCorrelation_list));
      (yyval.yt_tReceive)->name = att.read((yyvsp[-7].yt_integer), "name");
      (yyval.yt_tReceive)->joinCondition = (yyvsp[-3].yt_standardElements)->joinCondition = att.read((yyvsp[-7].yt_integer), "joinCondition");    
      (yyval.yt_tReceive)->suppressJoinFailure = (yyvsp[-3].yt_standardElements)->suppressJoinFailure = att.read((yyvsp[-7].yt_integer), "suppressJoinFailure",  (att.topSJFStack()).getSJFValue());
      att.traceAM(string("tReceive: ") + ((yyval.yt_tReceive)->suppressJoinFailure)->name + string("\n"));
      att.popSJFStack();
      (yyval.yt_tReceive)->partnerLink = att.read((yyvsp[-7].yt_integer), "partnerLink");
      (yyval.yt_tReceive)->portType = att.read((yyvsp[-7].yt_integer), "portType");
      (yyval.yt_tReceive)->operation = att.read((yyvsp[-7].yt_integer), "operation");
      (yyval.yt_tReceive)->variable = att.read((yyvsp[-7].yt_integer), "variable");
      (yyval.yt_tReceive)->createInstance = att.read((yyvsp[-7].yt_integer), "createInstance", (yyval.yt_tReceive)->createInstance); 
      (yyval.yt_tReceive)->variableID = symMan.checkVariable(att.read((yyvsp[-7].yt_integer), "variable")->name);
      (yyval.yt_tReceive)->channelID = symMan.addChannel(new csChannel((yyval.yt_tReceive)->portType->name, 
				      (yyval.yt_tReceive)->operation->name, 
				      (yyval.yt_tReceive)->partnerLink->name), true);
      if ((yyvsp[-3].yt_standardElements)->hasTarget)
      {
	symMan.remDPEstart();
      }
      if ((yyvsp[-3].yt_standardElements)->dpe->value > 0)
      {
        symMan.addDPEend();
      }
      (yyval.yt_tReceive)->negativeControlFlow = (yyvsp[-3].yt_standardElements)->negativeControlFlow = mkinteger( ((int) isInFH.top()) + 2*((int) isInCH.top().first));
      (yyval.yt_tReceive)->id = (yyvsp[-3].yt_standardElements)->parentId = (yyvsp[-7].yt_integer); }
    break;

  case 97:

    { 
      att.check((yyvsp[0].yt_integer), K_RECEIVE);
      if(att.isAttributeValueEmpty((yyvsp[0].yt_integer), "suppressJoinFailure"))
      {
      	/// parent BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), (att.topSJFStack()).getSJFValue());
      }
      else
      {
        /// current BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), att.read((yyvsp[0].yt_integer), "suppressJoinFailure"));      
      }
    }
    break;

  case 98:

    { impl_standardElements_StandardElements *noLinks = StandardElements(NiltTarget_list(), NiltSource_list());
      noLinks->parentId = (yyvsp[-2].yt_integer);
      (yyval.yt_tReceive) = Receive(noLinks, NiltCorrelation_list());
      (yyval.yt_tReceive)->name = att.read((yyvsp[-2].yt_integer), "name");
      (yyval.yt_tReceive)->joinCondition = att.read((yyvsp[-2].yt_integer), "joinCondition");     
      (yyval.yt_tReceive)->suppressJoinFailure = att.read((yyvsp[-2].yt_integer), "suppressJoinFailure",  (att.topSJFStack()).getSJFValue());
      att.traceAM(string("tReceive: ") + ((yyval.yt_tReceive)->suppressJoinFailure)->name + string("\n"));
      att.popSJFStack();
      (yyval.yt_tReceive)->partnerLink = att.read((yyvsp[-2].yt_integer), "partnerLink");
      (yyval.yt_tReceive)->portType = att.read((yyvsp[-2].yt_integer), "portType");
      (yyval.yt_tReceive)->operation = att.read((yyvsp[-2].yt_integer), "operation");
      (yyval.yt_tReceive)->variable = att.read((yyvsp[-2].yt_integer), "variable");
      (yyval.yt_tReceive)->createInstance = att.read((yyvsp[-2].yt_integer), "createInstance", (yyval.yt_tReceive)->createInstance);
      (yyval.yt_tReceive)->variableID = symMan.checkVariable(att.read((yyvsp[-2].yt_integer), "variable")->name);
      (yyval.yt_tReceive)->negativeControlFlow = noLinks->negativeControlFlow = mkinteger( ((int) isInFH.top()) + 2*((int) isInCH.top().first));
      (yyval.yt_tReceive)->id = (yyvsp[-2].yt_integer); 
      symMan.checkPartnerLink((yyval.yt_tReceive)->partnerLink->name); 
      (yyval.yt_tReceive)->channelID = symMan.addChannel(new csChannel((yyval.yt_tReceive)->portType->name, 
				      (yyval.yt_tReceive)->operation->name, 
				      (yyval.yt_tReceive)->partnerLink->name), true); 
    }
    break;

  case 99:

    { currentSymTabEntryKey = symTab.insert(K_RECEIVE);
    currentSymTabEntry = symTab.lookup(currentSymTabEntryKey); 
  }
    break;

  case 100:

    { 
      att.check((yyvsp[0].yt_integer), K_REPLY);
      if(att.isAttributeValueEmpty((yyvsp[0].yt_integer), "suppressJoinFailure"))
      {
      	/// parent BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), (att.topSJFStack()).getSJFValue());
      }
      else
      {
        /// current BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), att.read((yyvsp[0].yt_integer), "suppressJoinFailure"));      
      }
    }
    break;

  case 101:

    { (yyval.yt_tReply) = Reply((yyvsp[-3].yt_standardElements), (yyvsp[-2].yt_tCorrelation_list));
      (yyval.yt_tReply)->name = att.read((yyvsp[-6].yt_integer), "name");
      (yyval.yt_tReply)->joinCondition = (yyvsp[-3].yt_standardElements)->joinCondition = att.read((yyvsp[-6].yt_integer), "joinCondition");
      (yyval.yt_tReply)->suppressJoinFailure = (yyvsp[-3].yt_standardElements)->suppressJoinFailure = att.read((yyvsp[-6].yt_integer), "suppressJoinFailure",  (att.topSJFStack()).getSJFValue());
      att.traceAM(string("tReply: ") + ((yyval.yt_tReply)->suppressJoinFailure)->name + string("\n"));
      att.popSJFStack();
      (yyval.yt_tReply)->partnerLink = att.read((yyvsp[-6].yt_integer), "partnerLink");
      (yyval.yt_tReply)->portType = att.read((yyvsp[-6].yt_integer), "portType");
      (yyval.yt_tReply)->operation = att.read((yyvsp[-6].yt_integer), "operation");
      (yyval.yt_tReply)->variable = att.read((yyvsp[-6].yt_integer), "variable");
      (yyval.yt_tReply)->faultName = att.read((yyvsp[-6].yt_integer), "faultName");
      (yyval.yt_tReply)->variableID = symMan.checkVariable(att.read((yyvsp[-6].yt_integer), "variable")->name);
      symMan.checkPartnerLink((yyval.yt_tReply)->partnerLink->name); 
      (yyval.yt_tReply)->channelID = symMan.addChannel(new csChannel((yyval.yt_tReply)->portType->name, 
				      (yyval.yt_tReply)->operation->name, 
				      (yyval.yt_tReply)->partnerLink->name), false);
      if ((yyvsp[-3].yt_standardElements)->hasTarget)
      {
	symMan.remDPEstart();
      }
      if ((yyvsp[-3].yt_standardElements)->dpe->value > 0)
      {
        symMan.addDPEend();
      }
      (yyval.yt_tReply)->negativeControlFlow = (yyvsp[-3].yt_standardElements)->negativeControlFlow = mkinteger( ((int) isInFH.top()) + 2*((int) isInCH.top().first));
      (yyval.yt_tReply)->id = (yyvsp[-3].yt_standardElements)->parentId = (yyvsp[-6].yt_integer); }
    break;

  case 102:

    { 
      att.check((yyvsp[0].yt_integer), K_REPLY);
      if(att.isAttributeValueEmpty((yyvsp[0].yt_integer), "suppressJoinFailure"))
      {
      	/// parent BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), (att.topSJFStack()).getSJFValue());
      }
      else
      {
        /// current BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), att.read((yyvsp[0].yt_integer), "suppressJoinFailure"));      
      }
    }
    break;

  case 103:

    { impl_standardElements_StandardElements *noLinks = StandardElements(NiltTarget_list(), NiltSource_list());
      noLinks->parentId = (yyvsp[-2].yt_integer);
      (yyval.yt_tReply) = Reply(noLinks, NiltCorrelation_list());
      (yyval.yt_tReply)->name = att.read((yyvsp[-2].yt_integer), "name");
      (yyval.yt_tReply)->joinCondition = att.read((yyvsp[-2].yt_integer), "joinCondition");    
      (yyval.yt_tReply)->suppressJoinFailure = att.read((yyvsp[-2].yt_integer), "suppressJoinFailure",  (att.topSJFStack()).getSJFValue());
      att.traceAM(string("tReply: ") + ((yyval.yt_tReply)->suppressJoinFailure)->name + string("\n"));
      att.popSJFStack();
      (yyval.yt_tReply)->partnerLink = att.read((yyvsp[-2].yt_integer), "partnerLink");
      (yyval.yt_tReply)->portType = att.read((yyvsp[-2].yt_integer), "portType");
      (yyval.yt_tReply)->operation = att.read((yyvsp[-2].yt_integer), "operation");
      (yyval.yt_tReply)->variable = att.read((yyvsp[-2].yt_integer), "variable");
      (yyval.yt_tReply)->faultName = att.read((yyvsp[-2].yt_integer), "faultName");
      (yyval.yt_tReply)->variableID = symMan.checkVariable(att.read((yyvsp[-2].yt_integer), "variable")->name);
      symMan.checkPartnerLink((yyval.yt_tReply)->partnerLink->name); 
      (yyval.yt_tReply)->channelID = symMan.addChannel(new csChannel((yyval.yt_tReply)->portType->name, 
				      (yyval.yt_tReply)->operation->name, 
				      (yyval.yt_tReply)->partnerLink->name), false);
      (yyval.yt_tReply)->negativeControlFlow = noLinks->negativeControlFlow = mkinteger( ((int) isInFH.top()) + 2*((int) isInCH.top().first));
      (yyval.yt_tReply)->id = (yyvsp[-2].yt_integer); }
    break;

  case 104:

    { currentSymTabEntryKey = symTab.insert(K_REPLY);
    currentSymTabEntry = symTab.lookup(currentSymTabEntryKey); 
  }
    break;

  case 105:

    { currentSymTabEntryKey = symTab.insert(K_ASSIGN);
    currentSymTabEntry = symTab.lookup(currentSymTabEntryKey); 
  }
    break;

  case 106:

    { 
      att.check((yyvsp[0].yt_integer), K_ASSIGN);
      if(att.isAttributeValueEmpty((yyvsp[0].yt_integer), "suppressJoinFailure"))
      {
      	/// parent BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), (att.topSJFStack()).getSJFValue());
      }
      else
      {
        /// current BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), att.read((yyvsp[0].yt_integer), "suppressJoinFailure"));      
      }
    }
    break;

  case 107:

    { (yyval.yt_tAssign) = Assign((yyvsp[-3].yt_standardElements), (yyvsp[-2].yt_tCopy_list));
      (yyval.yt_tAssign)->name = att.read((yyvsp[-6].yt_integer), "name");
      (yyval.yt_tAssign)->joinCondition = (yyvsp[-3].yt_standardElements)->joinCondition = att.read((yyvsp[-6].yt_integer), "joinCondition");     
      (yyval.yt_tAssign)->suppressJoinFailure = (yyvsp[-3].yt_standardElements)->suppressJoinFailure = att.read((yyvsp[-6].yt_integer), "suppressJoinFailure",  (att.topSJFStack()).getSJFValue());
      att.traceAM(string("tAssign: ") + ((yyval.yt_tAssign)->suppressJoinFailure)->name + string("\n"));
      att.popSJFStack();
      if ((yyvsp[-3].yt_standardElements)->hasTarget)
      {
	symMan.remDPEstart();
      }
      if ((yyvsp[-3].yt_standardElements)->dpe->value > 0)
      {
        symMan.addDPEend();
      }
      (yyval.yt_tAssign)->negativeControlFlow = (yyvsp[-3].yt_standardElements)->negativeControlFlow = mkinteger( ((int) isInFH.top()) + 2*((int) isInCH.top().first));
      (yyval.yt_tAssign)->id = (yyvsp[-3].yt_standardElements)->parentId = (yyvsp[-6].yt_integer); }
    break;

  case 108:

    { (yyval.yt_tCopy_list) = ConstCopy_list((yyvsp[-1].yt_tCopy), NiltCopy_list()); }
    break;

  case 109:

    { (yyval.yt_tCopy_list) = ConstCopy_list((yyvsp[-2].yt_tCopy), (yyvsp[0].yt_tCopy_list)); }
    break;

  case 110:

    { (yyval.yt_tCopy) = Copy((yyvsp[-5].yt_tFrom), (yyvsp[-3].yt_tTo)); }
    break;

  case 111:

    { att.check((yyvsp[-3].yt_integer), K_FROM);
      (yyval.yt_tFrom) = From();
      (yyval.yt_tFrom)->variable = att.read((yyvsp[-3].yt_integer), "variable");
      (yyval.yt_tFrom)->part = att.read((yyvsp[-3].yt_integer), "part");
      (yyval.yt_tFrom)->query = att.read((yyvsp[-3].yt_integer), "query");
      (yyval.yt_tFrom)->partnerLink = att.read((yyvsp[-3].yt_integer), "partnerLink");
      (yyval.yt_tFrom)->endpointReference = att.read((yyvsp[-3].yt_integer), "endpointReference");
      (yyval.yt_tFrom)->property = att.read((yyvsp[-3].yt_integer), "property");
      (yyval.yt_tFrom)->expression = att.read((yyvsp[-3].yt_integer), "expression");
      (yyval.yt_tFrom)->opaque = att.read((yyvsp[-3].yt_integer), "opaque"); 
      (yyval.yt_tFrom)->variableID = symMan.checkVariable(att.read((yyvsp[-3].yt_integer), "variable")->name);
      symMan.checkPartnerLink((yyval.yt_tFrom)->partnerLink->name); }
    break;

  case 112:

    { att.check((yyvsp[-5].yt_integer), (yyvsp[-3].yt_casestring), K_FROM);
      (yyval.yt_tFrom) = From();
      (yyval.yt_tFrom)->variable = att.read((yyvsp[-5].yt_integer), "variable");
      (yyval.yt_tFrom)->part = att.read((yyvsp[-5].yt_integer), "part");
      (yyval.yt_tFrom)->query = att.read((yyvsp[-5].yt_integer), "query");
      (yyval.yt_tFrom)->partnerLink = att.read((yyvsp[-5].yt_integer), "partnerLink");
      (yyval.yt_tFrom)->endpointReference = att.read((yyvsp[-5].yt_integer), "endpointReference");
      (yyval.yt_tFrom)->property = att.read((yyvsp[-5].yt_integer), "property");
      (yyval.yt_tFrom)->expression = att.read((yyvsp[-5].yt_integer), "expression");
      (yyval.yt_tFrom)->opaque = att.read((yyvsp[-5].yt_integer), "opaque");
      (yyval.yt_tFrom)->literalValue = (yyvsp[-3].yt_casestring);
      (yyval.yt_tFrom)->variableID = symMan.checkVariable(att.read((yyvsp[-5].yt_integer), "variable")->name);
      symMan.checkPartnerLink((yyval.yt_tFrom)->partnerLink->name); }
    break;

  case 113:

    { att.check((yyvsp[-1].yt_integer), K_FROM);
      (yyval.yt_tFrom) = From();
      (yyval.yt_tFrom)->variable = att.read((yyvsp[-1].yt_integer), "variable");
      (yyval.yt_tFrom)->part = att.read((yyvsp[-1].yt_integer), "part");
      (yyval.yt_tFrom)->query = att.read((yyvsp[-1].yt_integer), "query");
      (yyval.yt_tFrom)->partnerLink = att.read((yyvsp[-1].yt_integer), "partnerLink");
      (yyval.yt_tFrom)->endpointReference = att.read((yyvsp[-1].yt_integer), "endpointReference");
      (yyval.yt_tFrom)->property = att.read((yyvsp[-1].yt_integer), "property");
      (yyval.yt_tFrom)->expression = att.read((yyvsp[-1].yt_integer), "expression");
      (yyval.yt_tFrom)->opaque = att.read((yyvsp[-1].yt_integer), "opaque"); 
      (yyval.yt_tFrom)->variableID = symMan.checkVariable(att.read((yyvsp[-1].yt_integer), "variable")->name);
      symMan.checkPartnerLink((yyval.yt_tFrom)->partnerLink->name); }
    break;

  case 114:

    { currentSymTabEntryKey = symTab.insert(K_FROM);
    currentSymTabEntry = symTab.lookup(currentSymTabEntryKey); 
  }
    break;

  case 115:

    { att.check((yyvsp[-3].yt_integer), K_TO);
      (yyval.yt_tTo) = To();
      (yyval.yt_tTo)->variable = att.read((yyvsp[-3].yt_integer), "variable");
      (yyval.yt_tTo)->part = att.read((yyvsp[-3].yt_integer), "part");
      (yyval.yt_tTo)->partnerLink = att.read((yyvsp[-3].yt_integer), "partnerLink");
      (yyval.yt_tTo)->property = att.read((yyvsp[-3].yt_integer), "property"); 
      (yyval.yt_tTo)->variableID = symMan.checkVariable(att.read((yyvsp[-3].yt_integer), "variable")->name);
      symMan.checkPartnerLink((yyval.yt_tTo)->partnerLink->name); }
    break;

  case 116:

    { att.check((yyvsp[-1].yt_integer), K_TO);
      (yyval.yt_tTo) = To();
      (yyval.yt_tTo)->variable = att.read((yyvsp[-1].yt_integer), "variable");
      (yyval.yt_tTo)->part = att.read((yyvsp[-1].yt_integer), "part");
      (yyval.yt_tTo)->partnerLink = att.read((yyvsp[-1].yt_integer), "partnerLink");
      (yyval.yt_tTo)->property = att.read((yyvsp[-1].yt_integer), "property"); 
      (yyval.yt_tTo)->variableID = symMan.checkVariable(att.read((yyvsp[-1].yt_integer), "variable")->name);
      symMan.checkPartnerLink((yyval.yt_tTo)->partnerLink->name); }
    break;

  case 117:

    { currentSymTabEntryKey = symTab.insert(K_TO);
    currentSymTabEntry = symTab.lookup(currentSymTabEntryKey); 
  }
    break;

  case 118:

    { 
      att.check((yyvsp[0].yt_integer), K_WAIT);
      if(att.isAttributeValueEmpty((yyvsp[0].yt_integer), "suppressJoinFailure"))
      {
      	/// parent BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), (att.topSJFStack()).getSJFValue());
      }
      else
      {
        /// current BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), att.read((yyvsp[0].yt_integer), "suppressJoinFailure"));      
      }
    }
    break;

  case 119:

    { (yyval.yt_tWait) = Wait((yyvsp[-2].yt_standardElements));
      (yyval.yt_tWait)->name = att.read((yyvsp[-5].yt_integer), "name");
      (yyval.yt_tWait)->joinCondition = (yyvsp[-2].yt_standardElements)->joinCondition = att.read((yyvsp[-5].yt_integer), "joinCondition");     
      (yyval.yt_tWait)->suppressJoinFailure = (yyvsp[-2].yt_standardElements)->suppressJoinFailure = att.read((yyvsp[-5].yt_integer), "suppressJoinFailure",  (att.topSJFStack()).getSJFValue());
      att.traceAM(string("tWait: ") + ((yyval.yt_tWait)->suppressJoinFailure)->name + string("\n"));
      att.popSJFStack();      
      (yyval.yt_tWait)->For = att.read((yyvsp[-5].yt_integer), "for"); // "for" is a keyword
      (yyval.yt_tWait)->until = att.read((yyvsp[-5].yt_integer), "until");
      if ((yyvsp[-2].yt_standardElements)->hasTarget)
      {
	symMan.remDPEstart();
      }
      if ((yyvsp[-2].yt_standardElements)->dpe->value > 0)
      {
        symMan.addDPEend();
      }
      (yyval.yt_tWait)->negativeControlFlow = (yyvsp[-2].yt_standardElements)->negativeControlFlow = mkinteger( ((int) isInFH.top()) + 2*((int) isInCH.top().first));
      (yyval.yt_tWait)->id = (yyvsp[-2].yt_standardElements)->parentId = (yyvsp[-5].yt_integer); }
    break;

  case 120:

    { 
      att.check((yyvsp[0].yt_integer), K_WAIT);
      if(att.isAttributeValueEmpty((yyvsp[0].yt_integer), "suppressJoinFailure"))
      {
      	/// parent BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), (att.topSJFStack()).getSJFValue());
      }
      else
      {
        /// current BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), att.read((yyvsp[0].yt_integer), "suppressJoinFailure"));      
      }
    }
    break;

  case 121:

    { impl_standardElements_StandardElements *noLinks = StandardElements(NiltTarget_list(), NiltSource_list());
      noLinks->parentId = (yyvsp[-2].yt_integer);
      (yyval.yt_tWait) = Wait(noLinks);
      (yyval.yt_tWait)->name = att.read((yyvsp[-2].yt_integer), "name");
      (yyval.yt_tWait)->joinCondition = att.read((yyvsp[-2].yt_integer), "joinCondition");    
      (yyval.yt_tWait)->suppressJoinFailure = att.read((yyvsp[-2].yt_integer), "suppressJoinFailure",  (att.topSJFStack()).getSJFValue());
      att.traceAM(string("tWait: ") + ((yyval.yt_tWait)->suppressJoinFailure)->name + string("\n"));
      att.popSJFStack();      
      (yyval.yt_tWait)->For = att.read((yyvsp[-2].yt_integer), "for"); // "for" is a keyword
      (yyval.yt_tWait)->until = att.read((yyvsp[-2].yt_integer), "until");
      (yyval.yt_tWait)->negativeControlFlow = noLinks->negativeControlFlow = mkinteger( ((int) isInFH.top()) + 2*((int) isInCH.top().first));
      (yyval.yt_tWait)->id = (yyvsp[-2].yt_integer); }
    break;

  case 122:

    { currentSymTabEntryKey = symTab.insert(K_WAIT);
    currentSymTabEntry = symTab.lookup(currentSymTabEntryKey); 
  }
    break;

  case 123:

    { 
      att.check((yyvsp[0].yt_integer), K_THROW);
      if(att.isAttributeValueEmpty((yyvsp[0].yt_integer), "suppressJoinFailure"))
      {
      	/// parent BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), (att.topSJFStack()).getSJFValue());
      }
      else
      {
        /// current BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), att.read((yyvsp[0].yt_integer), "suppressJoinFailure"));      
      }
    }
    break;

  case 124:

    { att.check((yyvsp[-5].yt_integer), K_THROW);
      (yyval.yt_tThrow) = Throw((yyvsp[-2].yt_standardElements));
      (yyval.yt_tThrow)->name = att.read((yyvsp[-5].yt_integer), "name");
      (yyval.yt_tThrow)->joinCondition = (yyvsp[-2].yt_standardElements)->joinCondition = att.read((yyvsp[-5].yt_integer), "joinCondition");    
      (yyval.yt_tThrow)->suppressJoinFailure = (yyvsp[-2].yt_standardElements)->suppressJoinFailure = att.read((yyvsp[-5].yt_integer), "suppressJoinFailure",  (att.topSJFStack()).getSJFValue());
      att.traceAM(string("tThrow: ") + ((yyval.yt_tThrow)->suppressJoinFailure)->name + string("\n"));
      att.popSJFStack();      
      (yyval.yt_tThrow)->faultName = att.read((yyvsp[-5].yt_integer), "faultName");
      (yyval.yt_tThrow)->faultVariable = att.read((yyvsp[-5].yt_integer), "faultVariable");
      (yyval.yt_tThrow)->variableID = symMan.checkVariable(att.read((yyvsp[-5].yt_integer), "faultVariable")->name);
      if ((yyvsp[-2].yt_standardElements)->hasTarget)
      {
	symMan.remDPEstart();
      }
      if ((yyvsp[-2].yt_standardElements)->dpe->value > 0)
      {
        symMan.addDPEend();
      }
      (yyval.yt_tThrow)->negativeControlFlow = (yyvsp[-2].yt_standardElements)->negativeControlFlow = mkinteger( ((int) isInFH.top()) + 2*((int) isInCH.top().first));
      (yyval.yt_tThrow)->id = (yyvsp[-2].yt_standardElements)->parentId = (yyvsp[-5].yt_integer); }
    break;

  case 125:

    { 
      att.check((yyvsp[0].yt_integer), K_THROW);
      if(att.isAttributeValueEmpty((yyvsp[0].yt_integer), "suppressJoinFailure"))
      {
      	/// parent BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), (att.topSJFStack()).getSJFValue());
      }
      else
      {
        /// current BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), att.read((yyvsp[0].yt_integer), "suppressJoinFailure"));      
      }
    }
    break;

  case 126:

    { impl_standardElements_StandardElements *noLinks = StandardElements(NiltTarget_list(), NiltSource_list());
      noLinks->parentId = (yyvsp[-2].yt_integer);
      (yyval.yt_tThrow) = Throw(noLinks);
      (yyval.yt_tThrow)->name = att.read((yyvsp[-2].yt_integer), "name");
      (yyval.yt_tThrow)->joinCondition = att.read((yyvsp[-2].yt_integer), "joinCondition");   
      (yyval.yt_tThrow)->suppressJoinFailure = att.read((yyvsp[-2].yt_integer), "suppressJoinFailure",  (att.topSJFStack()).getSJFValue());
      att.traceAM(string("tThrow: ") + ((yyval.yt_tThrow)->suppressJoinFailure)->name + string("\n"));
      att.popSJFStack();
      (yyval.yt_tThrow)->faultName = att.read((yyvsp[-2].yt_integer), "faultName");
      (yyval.yt_tThrow)->faultVariable = att.read((yyvsp[-2].yt_integer), "faultVariable");
      (yyval.yt_tThrow)->variableID = symMan.checkVariable(att.read((yyvsp[-2].yt_integer), "faultVariable")->name);
      (yyval.yt_tThrow)->negativeControlFlow = noLinks->negativeControlFlow = mkinteger( ((int) isInFH.top()) + 2*((int) isInCH.top().first));
      (yyval.yt_tThrow)->id = (yyvsp[-2].yt_integer); }
    break;

  case 127:

    { currentSymTabEntryKey = symTab.insert(K_THROW);
    currentSymTabEntry = symTab.lookup(currentSymTabEntryKey); 
  }
    break;

  case 128:

    { 
      att.check((yyvsp[0].yt_integer), K_COMPENSATE);

      // compensate only is allowed within Compensation- or FaultHandler
      if ( ! (isInCH.top().first || isInFH.top()) )
      {
        yyerror(string("The activity <compensate> is only allowed with in a Compensation of FaultHandler.\n").c_str());
      }
      if(string(att.read((yyvsp[0].yt_integer), "scope")->name) == "")
      {
        if ( hasCompensate > 0)
        {
          yyerror(string("You may only define one <compensate> if you're using it without attributes.\n").c_str());
        }
        hasCompensate = 1;
      }
      else
      {
        if ( hasCompensate == 1)
        {
          yyerror(string("You may only define one <compensate> if you're using it without attributes.\n").c_str());
        }
        hasCompensate = 2;
      }

      if(att.isAttributeValueEmpty((yyvsp[0].yt_integer), "suppressJoinFailure"))
      {
      	/// parent BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), (att.topSJFStack()).getSJFValue());
      }
      else
      {
        /// current BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), att.read((yyvsp[0].yt_integer), "suppressJoinFailure"));      
      }
    }
    break;

  case 129:

    { (yyval.yt_tCompensate) = Compensate((yyvsp[-2].yt_standardElements));
      (yyval.yt_tCompensate)->name = att.read((yyvsp[-5].yt_integer), "name");
      (yyval.yt_tCompensate)->joinCondition = (yyvsp[-2].yt_standardElements)->joinCondition = att.read((yyvsp[-5].yt_integer), "joinCondition");   
      (yyval.yt_tCompensate)->suppressJoinFailure = (yyvsp[-2].yt_standardElements)->suppressJoinFailure = att.read((yyvsp[-5].yt_integer), "suppressJoinFailure",  (att.topSJFStack()).getSJFValue());
      att.traceAM(string("tCompensate: ") + ((yyval.yt_tCompensate)->suppressJoinFailure)->name + string("\n"));
      att.popSJFStack();
      (yyval.yt_tCompensate)->scope = att.read((yyvsp[-5].yt_integer), "scope");
      if ((yyvsp[-2].yt_standardElements)->hasTarget)
      {
	symMan.remDPEstart();
      }
      if ((yyvsp[-2].yt_standardElements)->dpe->value > 0)
      {
        symMan.addDPEend();
      }
      (yyval.yt_tCompensate)->negativeControlFlow = (yyvsp[-2].yt_standardElements)->negativeControlFlow = mkinteger( ((int) isInFH.top()) + 2*((int) isInCH.top().first));
      (yyval.yt_tCompensate)->id = (yyvsp[-2].yt_standardElements)->parentId = (yyvsp[-5].yt_integer); }
    break;

  case 130:

    { 
      att.check((yyvsp[0].yt_integer), K_COMPENSATE);

      // compensate only is allowed within Compensation- or FaultHandler
      if ( ! (isInCH.top().first || isInFH.top()) )
      {
        yyerror(string("The activity <compensate> is only allowed with in a Compensation of FaultHandler.\n").c_str());
      }
      if(string(att.read((yyvsp[0].yt_integer), "scope")->name) == "")
      {
        if ( hasCompensate > 0)
        {
          yyerror(string("You may only define one <compensate> if you're using it without attributes.\n").c_str());
        }
        hasCompensate = 1;
      }
      else
      {
        if ( hasCompensate == 1)
        {
          yyerror(string("You may only define one <compensate> if you're using it without attributes.\n").c_str());
        }
        hasCompensate = 2;
      }

      if(att.isAttributeValueEmpty((yyvsp[0].yt_integer), "suppressJoinFailure"))
      {
      	/// parent BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), (att.topSJFStack()).getSJFValue());
      }
      else
      {
        /// current BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), att.read((yyvsp[0].yt_integer), "suppressJoinFailure"));      
      }
    }
    break;

  case 131:

    { impl_standardElements_StandardElements *noLinks = StandardElements(NiltTarget_list(), NiltSource_list());
      noLinks->parentId = (yyvsp[-2].yt_integer);
      (yyval.yt_tCompensate) = Compensate(noLinks);
      (yyval.yt_tCompensate)->name = att.read((yyvsp[-2].yt_integer), "name");
      (yyval.yt_tCompensate)->joinCondition = att.read((yyvsp[-2].yt_integer), "joinCondition");     
      (yyval.yt_tCompensate)->suppressJoinFailure = att.read((yyvsp[-2].yt_integer), "suppressJoinFailure",  (att.topSJFStack()).getSJFValue());
      att.traceAM(string("tCompensate: ") + ((yyval.yt_tCompensate)->suppressJoinFailure)->name + string("\n"));
      att.popSJFStack();
      (yyval.yt_tCompensate)->scope = att.read((yyvsp[-2].yt_integer), "scope");
      (yyval.yt_tCompensate)->negativeControlFlow = noLinks->negativeControlFlow = mkinteger( ((int) isInFH.top()) + 2*((int) isInCH.top().first));
      (yyval.yt_tCompensate)->id = (yyvsp[-2].yt_integer); }
    break;

  case 132:

    { currentSymTabEntryKey = symTab.insert(K_COMPENSATE);
    currentSymTabEntry = symTab.lookup(currentSymTabEntryKey); 
  }
    break;

  case 133:

    { 
      att.check((yyvsp[0].yt_integer), K_TERMINATE);
      if(att.isAttributeValueEmpty((yyvsp[0].yt_integer), "suppressJoinFailure"))
      {
      	/// parent BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), (att.topSJFStack()).getSJFValue());
      }
      else
      {
        /// current BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), att.read((yyvsp[0].yt_integer), "suppressJoinFailure"));      
      }
    }
    break;

  case 134:

    { (yyval.yt_tTerminate) = Terminate((yyvsp[-2].yt_standardElements));
      (yyval.yt_tTerminate)->name = att.read((yyvsp[-5].yt_integer), "name");
      (yyval.yt_tTerminate)->joinCondition = (yyvsp[-2].yt_standardElements)->joinCondition = att.read((yyvsp[-5].yt_integer), "joinCondition");    
      (yyval.yt_tTerminate)->suppressJoinFailure = (yyvsp[-2].yt_standardElements)->suppressJoinFailure = att.read((yyvsp[-5].yt_integer), "suppressJoinFailure",  (att.topSJFStack()).getSJFValue());
      att.traceAM(string("tTerminate: ") + ((yyval.yt_tTerminate)->suppressJoinFailure)->name + string("\n"));
      att.popSJFStack();
      if ((yyvsp[-2].yt_standardElements)->hasTarget)
      {
	symMan.remDPEstart();
      }
      if ((yyvsp[-2].yt_standardElements)->dpe->value > 0)
      {
        symMan.addDPEend();
      }
      (yyval.yt_tTerminate)->negativeControlFlow = (yyvsp[-2].yt_standardElements)->negativeControlFlow = mkinteger( ((int) isInFH.top()) + 2*((int) isInCH.top().first));
      (yyval.yt_tTerminate)->id = (yyvsp[-2].yt_standardElements)->parentId = (yyvsp[-5].yt_integer); }
    break;

  case 135:

    { 
      att.check((yyvsp[0].yt_integer), K_TERMINATE);
      if(att.isAttributeValueEmpty((yyvsp[0].yt_integer), "suppressJoinFailure"))
      {
      	/// parent BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), (att.topSJFStack()).getSJFValue());
      }
      else
      {
        /// current BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), att.read((yyvsp[0].yt_integer), "suppressJoinFailure"));      
      }
    }
    break;

  case 136:

    { impl_standardElements_StandardElements *noLinks = StandardElements(NiltTarget_list(), NiltSource_list());
      noLinks->parentId = (yyvsp[-2].yt_integer);
      (yyval.yt_tTerminate) = Terminate(noLinks);
      (yyval.yt_tTerminate)->name = att.read((yyvsp[-2].yt_integer), "name");
      (yyval.yt_tTerminate)->joinCondition = att.read((yyvsp[-2].yt_integer), "joinCondition");     
      (yyval.yt_tTerminate)->suppressJoinFailure = att.read((yyvsp[-2].yt_integer), "suppressJoinFailure",  (att.topSJFStack()).getSJFValue());
      att.traceAM(string("tTerminate: ") + ((yyval.yt_tTerminate)->suppressJoinFailure)->name + string("\n"));
      att.popSJFStack();
      (yyval.yt_tTerminate)->negativeControlFlow = noLinks->negativeControlFlow = mkinteger( ((int) isInFH.top()) + 2*((int) isInCH.top().first));
      (yyval.yt_tTerminate)->id = (yyvsp[-2].yt_integer); }
    break;

  case 137:

    { currentSymTabEntryKey = symTab.insert(K_TERMINATE);
    currentSymTabEntry = symTab.lookup(currentSymTabEntryKey); 
  }
    break;

  case 138:

    { currentSymTabEntryKey = symTab.insert(K_FLOW);
    currentSymTabEntry = symTab.lookup(currentSymTabEntryKey); 
  }
    break;

  case 139:

    { 
      att.check((yyvsp[0].yt_integer), K_FLOW);
      if(att.isAttributeValueEmpty((yyvsp[0].yt_integer), "suppressJoinFailure"))
      {
      	/// parent BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), (att.topSJFStack()).getSJFValue());
      }
      else
      {
        /// current BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), att.read((yyvsp[0].yt_integer), "suppressJoinFailure"));      
      }
    }
    break;

  case 140:

    {
      symMan.newFlowScope((yyvsp[-2].yt_integer));
    }
    break;

  case 141:

    { (yyval.yt_tFlow) = Flow((yyvsp[-4].yt_standardElements), (yyvsp[-3].yt_tLink_list), (yyvsp[-2].yt_activity_list));
      (yyval.yt_tFlow)->name = att.read((yyvsp[-8].yt_integer), "name");
      (yyval.yt_tFlow)->joinCondition = (yyvsp[-4].yt_standardElements)->joinCondition = att.read((yyvsp[-8].yt_integer), "joinCondition");     
      (yyval.yt_tFlow)->suppressJoinFailure = (yyvsp[-4].yt_standardElements)->suppressJoinFailure = att.read((yyvsp[-8].yt_integer), "suppressJoinFailure",  (att.topSJFStack()).getSJFValue());
      att.traceAM(string("tFlow: ") + ((yyval.yt_tFlow)->suppressJoinFailure)->name + string("\n"));
      att.popSJFStack();
      (yyval.yt_tFlow)->dpe = mkinteger((symMan.needsDPE())->value);
      if ((yyvsp[-4].yt_standardElements)->hasTarget)
      {
	symMan.remDPEstart();
      }
      if ((yyvsp[-4].yt_standardElements)->dpe->value > 0)
      {
        symMan.addDPEend();
      }
      if ((yyval.yt_tFlow)->dpe->value > 0)
      {
	(yyvsp[-4].yt_standardElements)->dpe = mkinteger(1);
      }
      (yyval.yt_tFlow)->negativeControlFlow = (yyvsp[-4].yt_standardElements)->negativeControlFlow = mkinteger( ((int) isInFH.top()) + 2*((int) isInCH.top().first));
      (yyval.yt_tFlow)->id = (yyvsp[-4].yt_standardElements)->parentId = (yyvsp[-8].yt_integer);
      symMan.checkLinks();
      symMan.quitScope(); }
    break;

  case 142:

    { (yyval.yt_activity_list) = Consactivity_list((yyvsp[-1].yt_activity), Nilactivity_list()); 
      for(int i = 0; i < (yyvsp[-2].yt_integer)->value; ++i)
      { 
	symMan.addDPEend();
      }
      (yyval.yt_activity_list)->dpe = (yyvsp[-1].yt_activity)->dpe;
    }
    break;

  case 143:

    { (yyval.yt_activity_list) = Consactivity_list((yyvsp[-2].yt_activity), (yyvsp[0].yt_activity_list)); 
      for(int i = 0; i < (yyvsp[-3].yt_integer)->value; ++i)
      { 
	symMan.addDPEend();
      }
      (yyval.yt_activity_list)->dpe = mkinteger((yyvsp[-2].yt_activity)->dpe->value + (yyvsp[0].yt_activity_list)->dpe->value);
    }
    break;

  case 144:

    {
      (yyval.yt_integer) = symMan.needsDPE();
      symMan.resetDPEend();
    }
    break;

  case 145:

    { (yyval.yt_tLink_list) = NiltLink_list(); }
    break;

  case 146:

    { (yyval.yt_tLink_list) = (yyvsp[-3].yt_tLink_list); }
    break;

  case 147:

    { (yyval.yt_tLink_list) = ConstLink_list((yyvsp[-1].yt_tLink), NiltLink_list()); }
    break;

  case 148:

    { (yyval.yt_tLink_list) = ConstLink_list((yyvsp[-2].yt_tLink), (yyvsp[0].yt_tLink_list)); }
    break;

  case 149:

    { (yyval.yt_tLink) = Link();
      (yyval.yt_tLink)->name = att.read((yyvsp[-3].yt_integer), "name"); 
      (yyval.yt_tLink)->linkID = symMan.addLink(new csLink((yyval.yt_tLink)->name->name)); }
    break;

  case 150:

    { (yyval.yt_tLink) = Link();
      (yyval.yt_tLink)->name = att.read((yyvsp[-1].yt_integer), "name"); 
      (yyval.yt_tLink)->linkID = symMan.addLink(new csLink((yyval.yt_tLink)->name->name)); }
    break;

  case 151:

    { currentSymTabEntryKey = symTab.insert(K_LINK);
    currentSymTabEntry = symTab.lookup(currentSymTabEntryKey); 
  }
    break;

  case 152:

    { currentSymTabEntryKey = symTab.insert(K_SWITCH);
    currentSymTabEntry = symTab.lookup(currentSymTabEntryKey); 
  }
    break;

  case 153:

    { 
      att.check((yyvsp[0].yt_integer), K_SWITCH);
      if(att.isAttributeValueEmpty((yyvsp[0].yt_integer), "suppressJoinFailure"))
      {
      	/// parent BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), (att.topSJFStack()).getSJFValue());
      }
      else
      {
        /// current BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), att.read((yyvsp[0].yt_integer), "suppressJoinFailure"));      
      }
    }
    break;

  case 154:

    {
      symMan.addDPEstart();
    }
    break;

  case 155:

    { (yyval.yt_tSwitch) = Switch((yyvsp[-5].yt_standardElements), (yyvsp[-3].yt_tCase_list), (yyvsp[-2].yt_tOtherwise));
      (yyval.yt_tSwitch)->name = att.read((yyvsp[-8].yt_integer), "name");
      (yyval.yt_tSwitch)->joinCondition = (yyvsp[-5].yt_standardElements)->joinCondition = att.read((yyvsp[-8].yt_integer), "joinCondition");
      (yyval.yt_tSwitch)->suppressJoinFailure = (yyvsp[-5].yt_standardElements)->suppressJoinFailure = att.read((yyvsp[-8].yt_integer), "suppressJoinFailure",  (att.topSJFStack()).getSJFValue());
      att.traceAM(string("tSwitch: ") + ((yyval.yt_tSwitch)->suppressJoinFailure)->name + string("\n"));
      att.popSJFStack();
      symMan.remDPEstart();
      (yyval.yt_tSwitch)->dpe = symMan.needsDPE();
      if ((yyvsp[-5].yt_standardElements)->hasTarget)
      {
	symMan.remDPEstart();
      }
      if ((yyvsp[-5].yt_standardElements)->dpe->value > 0)
      {
        symMan.addDPEend();
      }
      if ((yyval.yt_tSwitch)->dpe->value > 0)
      {
	(yyvsp[-5].yt_standardElements)->dpe = mkinteger(1);
      }
      (yyval.yt_tSwitch)->negativeControlFlow = (yyvsp[-5].yt_standardElements)->negativeControlFlow = mkinteger( ((int) isInFH.top()) + 2*((int) isInCH.top().first));
      (yyval.yt_tSwitch)->id = (yyvsp[-5].yt_standardElements)->parentId = (yyvsp[-8].yt_integer);
    }
    break;

  case 156:

    { (yyval.yt_tCase_list) = ConstCase_list((yyvsp[-1].yt_tCase), NiltCase_list()); 
      for(int i = 0; i < (yyvsp[-2].yt_integer)->value; ++i)
      { 
	symMan.addDPEend();
      }
      (yyval.yt_tCase_list)->dpe = (yyvsp[-1].yt_tCase)->dpe;
    }
    break;

  case 157:

    { (yyval.yt_tCase_list) = ConstCase_list((yyvsp[-2].yt_tCase), (yyvsp[0].yt_tCase_list)); 
      for(int i = 0; i < (yyvsp[-3].yt_integer)->value; ++i)
      { 
	symMan.addDPEend();
      }
      (yyval.yt_tCase_list)->dpe = mkinteger((yyvsp[-2].yt_tCase)->dpe->value + (yyvsp[0].yt_tCase_list)->dpe->value);
    }
    break;

  case 158:

    {
      (yyval.yt_integer) = symMan.needsDPE();
      symMan.resetDPEend();
    }
    break;

  case 159:

    { currentSymTabEntryKey = symTab.insert(K_CASE);
    currentSymTabEntry = symTab.lookup(currentSymTabEntryKey); 
  }
    break;

  case 160:

    {
      // since we descend, set DPE ends to 0
      // symMan.resetDPEend();
    }
    break;

  case 161:

    { att.check((yyvsp[-6].yt_integer), K_CASE);
      (yyval.yt_tCase) = Case((yyvsp[-3].yt_activity));
      (yyval.yt_tCase)->condition = att.read((yyvsp[-6].yt_integer), "condition"); 
      (yyval.yt_tCase)->dpe = mkinteger((symMan.needsDPE())->value);
      
    }
    break;

  case 162:

    { // creaty empty activit with id, without links etc.
      integer id = att.nextId();
      impl_standardElements_StandardElements* noLinks = StandardElements(NiltTarget_list(),NiltSource_list());
//      noLinks->dpe = kc::mkinteger(0);
      noLinks->parentId = id;
      impl_tEmpty_Empty* implicitEmpty = Empty(noLinks);
      implicitEmpty->id = id;
      implicitEmpty->negativeControlFlow = noLinks->negativeControlFlow = mkinteger(0);
//      implicitEmpty->dpe = mkinteger(0);
      implicitEmpty->name = mkcasestring("implicit empty in otherwise");
      impl_activity *otherwiseActivity = activityEmpty(implicitEmpty);
      otherwiseActivity->id = id;

      currentSymTabEntryKey = symTab.insert(K_OTHERWISE);
      currentSymTabEntry = symTab.lookup(currentSymTabEntryKey); 
      currentSymTabEntryKey = symTab.insert(K_EMPTY);
      currentSymTabEntry = symTab.lookup(currentSymTabEntryKey); 
      symTab.setMapping(currentSymTabEntryKey, id);

      (yyval.yt_tOtherwise) = Otherwise(otherwiseActivity);
      (yyval.yt_tOtherwise)->dpe = kc::mkinteger(0);
    }
    break;

  case 163:

    {
      // since we descend, set DPE ends to 0
      symMan.resetDPEend();
    }
    break;

  case 164:

    { (yyval.yt_tOtherwise) = Otherwise((yyvsp[-4].yt_activity)); 
      (yyval.yt_tOtherwise)->dpe = symMan.needsDPE();
    }
    break;

  case 165:

    { currentSymTabEntryKey = symTab.insert(K_WHILE);
    currentSymTabEntry = symTab.lookup(currentSymTabEntryKey); 
  }
    break;

  case 166:

    { 
      att.check((yyvsp[0].yt_integer), K_WHILE);
      if(att.isAttributeValueEmpty((yyvsp[0].yt_integer), "suppressJoinFailure"))
      {
      	/// parent BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), (att.topSJFStack()).getSJFValue());
      }
      else
      {
        /// current BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), att.read((yyvsp[0].yt_integer), "suppressJoinFailure"));      
      }
    }
    break;

  case 167:

    { 
      symMan.startDPEinWhile();
    }
    break;

  case 168:

    { att.check((yyvsp[-8].yt_integer), K_WHILE);
      (yyval.yt_tWhile) = While((yyvsp[-5].yt_standardElements), (yyvsp[-3].yt_activity));
      (yyval.yt_tWhile)->name = att.read((yyvsp[-8].yt_integer), "name");
      (yyval.yt_tWhile)->joinCondition = (yyvsp[-5].yt_standardElements)->joinCondition = att.read((yyvsp[-8].yt_integer), "joinCondition");     
      (yyval.yt_tWhile)->suppressJoinFailure = (yyvsp[-5].yt_standardElements)->suppressJoinFailure = att.read((yyvsp[-8].yt_integer), "suppressJoinFailure", (att.topSJFStack()).getSJFValue());
      att.traceAM(string("tWhile: ") + ((yyval.yt_tWhile)->suppressJoinFailure)->name + string("\n"));
      att.popSJFStack();
      (yyval.yt_tWhile)->condition = att.read((yyvsp[-8].yt_integer), "condition");
      (yyval.yt_tWhile)->negativeControlFlow = (yyvsp[-5].yt_standardElements)->negativeControlFlow = mkinteger( ((int) isInFH.top()) + 2*((int) isInCH.top().first));
      (yyval.yt_tWhile)->id = (yyvsp[-5].yt_standardElements)->parentId = (yyvsp[-8].yt_integer); 
      symMan.endDPEinWhile();
    }
    break;

  case 169:

    { currentSymTabEntryKey = symTab.insert(K_SEQUENCE);
    currentSymTabEntry = symTab.lookup(currentSymTabEntryKey); 
  }
    break;

  case 170:

    { 
      att.check((yyvsp[0].yt_integer), K_SEQUENCE);
      if(att.isAttributeValueEmpty((yyvsp[0].yt_integer), "suppressJoinFailure"))
      {
      	/// parent BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), (att.topSJFStack()).getSJFValue());
      }
      else
      {
        /// current BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), att.read((yyvsp[0].yt_integer), "suppressJoinFailure"));      
      }
    }
    break;

  case 171:

    { (yyval.yt_tSequence) = Sequence((yyvsp[-3].yt_standardElements), (yyvsp[-2].yt_activity_list));
      (yyval.yt_tSequence)->name = att.read((yyvsp[-6].yt_integer), "name");
      (yyval.yt_tSequence)->joinCondition = (yyvsp[-3].yt_standardElements)->joinCondition = att.read((yyvsp[-6].yt_integer), "joinCondition");
      (yyval.yt_tSequence)->suppressJoinFailure = (yyvsp[-3].yt_standardElements)->suppressJoinFailure = att.read((yyvsp[-6].yt_integer), "suppressJoinFailure", (att.topSJFStack()).getSJFValue());
      att.traceAM(string("tSequence: ") + ((yyval.yt_tSequence)->suppressJoinFailure)->name + string("\n"));
      att.popSJFStack();
      (yyval.yt_tSequence)->negativeControlFlow = (yyvsp[-3].yt_standardElements)->negativeControlFlow = mkinteger( ((int) isInFH.top()) + 2*((int) isInCH.top().first));
      (yyval.yt_tSequence)->id = (yyvsp[-3].yt_standardElements)->parentId = (yyvsp[-6].yt_integer); 
      (yyval.yt_tSequence)->dpe = mkinteger((symMan.needsDPE())->value);
      if ((yyvsp[-3].yt_standardElements)->hasTarget)
      {
	symMan.remDPEstart();
      }
      if ((yyvsp[-3].yt_standardElements)->dpe->value > 0)
      {
        symMan.addDPEend();
      }
      if ((yyval.yt_tSequence)->dpe->value > 0)
      {
	(yyvsp[-3].yt_standardElements)->dpe = mkinteger(1);
      }
    }
    break;

  case 172:

    { currentSymTabEntryKey = symTab.insert(K_PICK);
    currentSymTabEntry = symTab.lookup(currentSymTabEntryKey); 
  }
    break;

  case 173:

    { 
      att.check((yyvsp[0].yt_integer), K_PICK);
      if(att.isAttributeValueEmpty((yyvsp[0].yt_integer), "suppressJoinFailure"))
      {
      	/// parent BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), (att.topSJFStack()).getSJFValue());
      }
      else
      {
        /// current BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), att.read((yyvsp[0].yt_integer), "suppressJoinFailure"));      
      }
    }
    break;

  case 174:

    {
      symMan.addDPEstart();
    }
    break;

  case 175:

    { (yyval.yt_tPick) = Pick((yyvsp[-7].yt_standardElements), ConstOnMessage_list((yyvsp[-5].yt_tOnMessage), (yyvsp[-3].yt_tOnMessage_list)), (yyvsp[-2].yt_tOnAlarm_list));
      (yyval.yt_tPick)->name = att.read((yyvsp[-10].yt_integer), "name");
      (yyval.yt_tPick)->joinCondition = (yyvsp[-7].yt_standardElements)->joinCondition = att.read((yyvsp[-10].yt_integer), "joinCondition");
      (yyval.yt_tPick)->suppressJoinFailure = (yyvsp[-7].yt_standardElements)->suppressJoinFailure = att.read((yyvsp[-10].yt_integer), "suppressJoinFailure", (att.topSJFStack()).getSJFValue());
      att.traceAM(string("tPick: ") + ((yyval.yt_tPick)->suppressJoinFailure)->name + string("\n"));
      att.popSJFStack();
      (yyval.yt_tPick)->createInstance = att.read((yyvsp[-10].yt_integer), "createInstance", (yyval.yt_tPick)->createInstance);
      symMan.remDPEstart();
      (yyval.yt_tPick)->dpe = symMan.needsDPE();
      if ((yyvsp[-7].yt_standardElements)->hasTarget)
      {
	symMan.remDPEstart();
      }
      if ((yyvsp[-7].yt_standardElements)->dpe->value > 0)
      {
        symMan.addDPEend();
      }
      if ((yyval.yt_tPick)->dpe->value > 0)
      {
	(yyvsp[-7].yt_standardElements)->dpe = mkinteger(1);
      }
      (yyval.yt_tPick)->id = (yyvsp[-7].yt_standardElements)->parentId = (yyvsp[-10].yt_integer);
      (yyval.yt_tPick)->negativeControlFlow = (yyvsp[-7].yt_standardElements)->negativeControlFlow = mkinteger( ((int) isInFH.top()) + 2*((int) isInCH.top().first));
    }
    break;

  case 176:

    { currentSymTabEntryKey = symTab.insert(K_SCOPE);
    currentSymTabEntry = symTab.lookup(currentSymTabEntryKey); 
  }
    break;

  case 177:

    { 
      att.check((yyvsp[0].yt_integer), K_SCOPE);
      if(att.isAttributeValueEmpty((yyvsp[0].yt_integer), "suppressJoinFailure"))
      {
      	/// parent BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), (att.topSJFStack()).getSJFValue());
      }
      else
      {
        /// current BPEL-element attribute value
      	att.pushSJFStack((yyvsp[0].yt_integer), att.read((yyvsp[0].yt_integer), "suppressJoinFailure"));      
      }
    }
    break;

  case 178:

    { symMan.newScopeScope((yyvsp[-2].yt_integer));
      symMan.setBlackListMode(true);
      isInFH.push(false);
      isInCH.push(pair<bool,int>(false,hasCompensate));
      parent[(yyvsp[-2].yt_integer)] = currentScopeId;
      currentScopeId = (yyvsp[-2].yt_integer); }
    break;

  case 179:

    {
      symMan.setBlackListMode(false);
    }
    break;

  case 180:

    { att.check((yyvsp[-14].yt_integer), K_SCOPE);
      isInFH.pop();
      hasCompensate = isInCH.top().second;
      isInCH.pop();
      (yyval.yt_tScope) = Scope((yyvsp[-10].yt_standardElements), (yyvsp[-8].yt_tVariable_list), (yyvsp[-6].yt_tFaultHandlers), (yyvsp[-5].yt_tCompensationHandler), (yyvsp[-4].yt_tEventHandlers), StopInScope(), (yyvsp[-3].yt_activity));
      (yyval.yt_tScope)->name = att.read((yyvsp[-14].yt_integer), "name");
      (yyval.yt_tScope)->joinCondition = (yyvsp[-10].yt_standardElements)->joinCondition = att.read((yyvsp[-14].yt_integer), "joinCondition");
      (yyval.yt_tScope)->suppressJoinFailure = (yyvsp[-10].yt_standardElements)->suppressJoinFailure = att.read((yyvsp[-14].yt_integer), "suppressJoinFailure", (att.topSJFStack()).getSJFValue());
      att.traceAM(string("tScope: ") + ((yyval.yt_tScope)->suppressJoinFailure)->name + string("\n"));
      att.popSJFStack();
      (yyval.yt_tScope)->variableAccessSerializable = att.read((yyvsp[-14].yt_integer), "variableAccessSerializable", (yyval.yt_tScope)->variableAccessSerializable);
      (yyval.yt_tScope)->negativeControlFlow = (yyvsp[-10].yt_standardElements)->negativeControlFlow = mkinteger( ((int) isInFH.top()) + 2*((int) isInCH.top().first));
      (yyval.yt_tScope)->id = (yyvsp[-10].yt_standardElements)->parentId = (yyvsp[-14].yt_integer);
      (yyval.yt_tScope)->parentScopeId = currentScopeId = parent[(yyvsp[-14].yt_integer)];
      (yyval.yt_tScope)->dpe = mkinteger((symMan.needsDPE())->value);
      if ((yyvsp[-10].yt_standardElements)->hasTarget)
      {
	symMan.remDPEstart();
      }
      (yyval.yt_tScope)->hasEH = (string((yyvsp[-4].yt_tEventHandlers)->op_name()) == "userDefinedEventHandler");
      if ((yyvsp[-10].yt_standardElements)->dpe->value > 0)
      {
        symMan.addDPEend();
      }
      if ((yyval.yt_tScope)->dpe->value > 0)
      {
	(yyvsp[-10].yt_standardElements)->dpe = mkinteger(1);
      }
      symMan.quitScope(); }
    break;

  case 181:

    { (yyval.yt_standardElements) = StandardElements((yyvsp[-1].yt_tTarget_list), (yyvsp[0].yt_tSource_list)); 
      (yyval.yt_standardElements)->dpe = (yyvsp[0].yt_tSource_list)->dpe;
      (yyval.yt_standardElements)->negativeControlFlow = mkinteger( ((int) isInFH.top()) + 2*((int) isInCH.top().first));
      if ((yyvsp[-1].yt_tTarget_list)->length() > 0)
      {
	symMan.addDPEstart();
	(yyval.yt_standardElements)->hasTarget = true;
      }
    }
    break;

  case 182:

    { (yyval.yt_tTarget_list) = NiltTarget_list(); 
    }
    break;

  case 183:

    { (yyval.yt_tTarget_list) = ConstTarget_list((yyvsp[-2].yt_tTarget), (yyvsp[0].yt_tTarget_list)); 
    }
    break;

  case 184:

    { att.check((yyvsp[-3].yt_integer), K_TARGET);
      (yyval.yt_tTarget) = Target();
      (yyval.yt_tTarget)->negativeControlFlow = mkinteger( ((int) isInFH.top()) + 2*((int) isInCH.top().first));
      (yyval.yt_tTarget)->linkName = att.read((yyvsp[-3].yt_integer), "linkName"); 
      (yyval.yt_tTarget)->linkID = symMan.checkLink((yyval.yt_tTarget)->linkName->name, false); }
    break;

  case 185:

    { att.check((yyvsp[-1].yt_integer), K_TARGET);
      (yyval.yt_tTarget) = Target();
      (yyval.yt_tTarget)->negativeControlFlow = mkinteger( ((int) isInFH.top()) + 2*((int) isInCH.top().first));
      (yyval.yt_tTarget)->linkName = att.read((yyvsp[-1].yt_integer), "linkName"); 
      (yyval.yt_tTarget)->linkID = symMan.checkLink((yyval.yt_tTarget)->linkName->name, false); }
    break;

  case 186:

    { currentSymTabEntryKey = symTab.insert(K_TARGET);
    currentSymTabEntry = symTab.lookup(currentSymTabEntryKey); 
  }
    break;

  case 187:

    { (yyval.yt_tSource_list) = NiltSource_list(); 
      (yyval.yt_tSource_list)->dpe = kc::mkinteger(0);
    }
    break;

  case 188:

    { (yyval.yt_tSource_list) = ConstSource_list((yyvsp[-2].yt_tSource), (yyvsp[0].yt_tSource_list));
      (yyval.yt_tSource_list)->dpe = kc::mkinteger((yyvsp[-2].yt_tSource)->dpe->value + (yyvsp[0].yt_tSource_list)->dpe->value);
    }
    break;

  case 189:

    { att.check((yyvsp[-3].yt_integer), K_SOURCE);
      (yyval.yt_tSource) = Source();
      (yyval.yt_tSource)->linkName = att.read((yyvsp[-3].yt_integer), "linkName");
      (yyval.yt_tSource)->transitionCondition = att.read((yyvsp[-3].yt_integer), "transitionCondition", (yyval.yt_tSource)->transitionCondition); 
      (yyval.yt_tSource)->linkID = symMan.checkLink((yyval.yt_tSource)->linkName->name, true); 
      symMan.addDPEend();
      (yyval.yt_tSource)->dpe = symMan.needsDPE();
      symMan.remDPEend();
      (yyval.yt_tSource)->negativeControlFlow = mkinteger( ((int) isInFH.top()) + 2*((int) isInCH.top().first));
    }
    break;

  case 190:

    { att.check((yyvsp[-1].yt_integer), K_SOURCE);
      (yyval.yt_tSource) = Source();
      (yyval.yt_tSource)->linkName = att.read((yyvsp[-1].yt_integer), "linkName");
      (yyval.yt_tSource)->transitionCondition = att.read((yyvsp[-1].yt_integer), "transitionCondition", (yyval.yt_tSource)->transitionCondition); 
      (yyval.yt_tSource)->linkID = symMan.checkLink((yyval.yt_tSource)->linkName->name, true);
      symMan.addDPEend();
      (yyval.yt_tSource)->dpe = symMan.needsDPE();
      symMan.remDPEend();
      (yyval.yt_tSource)->negativeControlFlow = mkinteger( ((int) isInFH.top()) + 2*((int) isInCH.top().first));
    }
    break;

  case 191:

    { currentSymTabEntryKey = symTab.insert(K_SOURCE);
    currentSymTabEntry = symTab.lookup(currentSymTabEntryKey); 
  }
    break;

  case 192:

    { (yyval.yt_integer) = att.nextId();
      symTab.setMapping(currentSymTabEntryKey, (yyval.yt_integer));
    }
    break;

  case 193:

    { (yyval.yt_integer) = (yyvsp[0].yt_integer);
      att.define((yyvsp[-3].yt_casestring), (yyvsp[-1].yt_casestring));
      symTab.addAttribute(currentSymTabEntryKey, symTab.newAttribute((yyvsp[-3].yt_casestring), (yyvsp[-1].yt_casestring)));
    }
    break;


      default: break;
    }

/* Line 1126 of yacc.c.  */


  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  int yytype = YYTRANSLATE (yychar);
	  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
	  YYSIZE_T yysize = yysize0;
	  YYSIZE_T yysize1;
	  int yysize_overflow = 0;
	  char *yymsg = 0;
#	  define YYERROR_VERBOSE_ARGS_MAXIMUM 5
	  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
	  int yyx;

#if 0
	  /* This is so xgettext sees the translatable formats that are
	     constructed on the fly.  */
	  YY_("syntax error, unexpected %s");
	  YY_("syntax error, unexpected %s, expecting %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s or %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
#endif
	  char *yyfmt;
	  char const *yyf;
	  static char const yyunexpected[] = "syntax error, unexpected %s";
	  static char const yyexpecting[] = ", expecting %s";
	  static char const yyor[] = " or %s";
	  char yyformat[sizeof yyunexpected
			+ sizeof yyexpecting - 1
			+ ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
			   * (sizeof yyor - 1))];
	  char const *yyprefix = yyexpecting;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 1;

	  yyarg[0] = yytname[yytype];
	  yyfmt = yystpcpy (yyformat, yyunexpected);

	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
		  {
		    yycount = 1;
		    yysize = yysize0;
		    yyformat[sizeof yyunexpected - 1] = '\0';
		    break;
		  }
		yyarg[yycount++] = yytname[yyx];
		yysize1 = yysize + yytnamerr (0, yytname[yyx]);
		yysize_overflow |= yysize1 < yysize;
		yysize = yysize1;
		yyfmt = yystpcpy (yyfmt, yyprefix);
		yyprefix = yyor;
	      }

	  yyf = YY_(yyformat);
	  yysize1 = yysize + yystrlen (yyf);
	  yysize_overflow |= yysize1 < yysize;
	  yysize = yysize1;

	  if (!yysize_overflow && yysize <= YYSTACK_ALLOC_MAXIMUM)
	    yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg)
	    {
	      /* Avoid sprintf, as that infringes on the user's name space.
		 Don't have undefined behavior even if the translation
		 produced a string with the wrong number of "%s"s.  */
	      char *yyp = yymsg;
	      int yyi = 0;
	      while ((*yyp = *yyf))
		{
		  if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		    {
		      yyp += yytnamerr (yyp, yyarg[yyi++]);
		      yyf += 2;
		    }
		  else
		    {
		      yyp++;
		      yyf++;
		    }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    {
	      yyerror (YY_("syntax error"));
	      goto yyexhaustedlab;
	    }
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror (YY_("syntax error"));
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
        }
      else
	{
	  yydestruct ("Error: discarding", yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (0)
     goto yyerrorlab;

yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping", yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token. */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK;
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}



